function clearBorder(dirPath, nWorkers)
    
imageList = dir(fullfile(dirPath,'*.tif*'));

parfor(i=1:length(imageList), nWorkers)
    currFilename = fullfile(dirPath, imageList(i).name);
    segIm = imread(currFilename);
    
    imBorder = [segIm(:,1); segIm(end,2:end-1)'; ....
                segIm(:,end); segIm(1,2:end-1)'];
    
    boundaryBlobLabels = unique(imBorder(imBorder > 0));
    
    for blobLabel = boundaryBlobLabels'
        segIm(segIm == blobLabel) = 0;
    end

    imwrite(segIm, currFilename);
end

end
