function channelMask = computeChannelMask(channelWidth,channelLength,offset)

if ~mod(channelWidth,2)
    error('Growth channel width must be an odd number!');
end

if nargin == 2 || isempty(offset)
    offset = ceil(tand(0.5)*channelLength);
end

maskWidth = channelWidth + 2*offset;
channelMask = zeros(maskWidth,channelLength);
channelMask(offset+1:offset+channelWidth,:) = 1;
