function rescaledIm = rescaleSingleImage(inputImage,maxVal,minVal)
% Rescales an image to use the full range of values for uint16 images.

import FastSeg.Preprocess.*

if ~isa(inputImage,'double')
    inputImage = double(inputImage);
end

if nargin == 1
    maxVal = max(max(inputImage));
    minVal = min(min(inputImage));
end

ratio = computeRescaleRatio(maxVal,minVal);

if ratio
    rescaledIm = uint16((inputImage-minVal) * ratio);
else
    rescaledIm = 65535*ones(size(inputImage));
end

end