function [E,dE_dmuX,dE_dmuY,dE_dlnBG,dE_dlnN,dE_dlnS]=psf_diff_psfGaussian(xx,yy,muX,muY,lnBG,lnN,lnS)
% [E,dE_dmuX,dE_dmuY,dE_dlnBG,dE_dlnN,dE_dlnS]=psf_diff_psfGaussian(xx,yy,muX,muY,lnBG,lnN,lnS)
% symmetric Gaussian PSF model and partial derivatives

N=exp(lnN);
S2=exp(2*lnS); % S^2
NEexp=N/S2*exp(-1/2/S2*((muX-xx).^2+(muY-yy).^2))/2/pi;

E=exp(lnBG)+NEexp;

if(nargout>1)
    dE_dmuX =-(muX-xx).*NEexp/S2;
    dE_dmuY =-(muY-yy).*NEexp/S2;
    dE_dlnBG=ones(size(E))*exp(lnBG);
    dE_dlnN = NEexp;
    dE_dlnS = NEexp.*(-2+((muX-xx).^2+(muY-yy).^2)/S2);
    % compute parameter dependent pixel intensities for symmetric Gaussian, with derivatives
    % ML 2015-11-17 : partial derivatives tested and accurate.
end
end
