function [blobsInFluo] = filterCellsByFluoRoi(mFrames,phaseIdx,fluoROI,phaseToFluoT)

allBlobs = mFrames.getBlobsInFrame(phaseIdx);
nBlobs = length(allBlobs);

isBlobInFluo = false(1,nBlobs);
for blobIdx = 1:nBlobs
    currBlob = allBlobs(blobIdx);
    cellsInBlob = mFrames.getCellsInBlob(phaseIdx, currBlob);
    c = cellsInBlob(1);
    t = c.getIndex(phaseIdx);
    
    cellBoundaryInPhase = double(c.convertFromCellCoord(t,c.boundaries{t}));
    cellBoundaryInPhase(:,3) = 1;
    cellBoundaryInFluo = cellBoundaryInPhase / phaseToFluoT;

    if min(cellBoundaryInFluo(:, 1)) >= fluoROI(1) && ...
       min(cellBoundaryInFluo(:, 2)) >= fluoROI(2) && ...
       max(cellBoundaryInFluo(:, 1)) <= fluoROI(1)+fluoROI(3)-1 && ...
       max(cellBoundaryInFluo(:, 2)) <= fluoROI(2)+fluoROI(4)-1
        % Current cell is completely inside roi of the fluo image
        isBlobInFluo(blobIdx) = true;
    end
end
blobsInFluo = allBlobs(isBlobInFluo);

end