function [filteredDots] = filterDotsByFluoRoi(dots,fluoROI)
% [filteredDots] = filterDotsByFluoRoi(dotCoord,fluoROI)
%
% Keep only dots inside fluo ROI
%
% Input:
%   dots - [x y frame]
%   fluoROI - [x0 y0 xDim yDim], where (x0,y0) is upper-left pixel coord

if isempty(dots)
    filteredDots = [];
    return;
end

xCoord = round(dots(:,1));
yCoord = round(dots(:,2));

innerDotIdx = xCoord >= fluoROI(1) & ...
              yCoord >= fluoROI(2) & ...
              xCoord <= fluoROI(1)+fluoROI(3)-1 & ...              
              yCoord <= fluoROI(2)+fluoROI(4)-1;

filteredDots = dots(innerDotIdx,:);