function outObj = getLogL_EMCCD_LookupTable(EMCCD_offsetName,EMgain,EMCCD_noiseStd,fluoChanName, expInfoObj)
persistent logLobj;
if ~isempty(logLobj)
    outObj = logLobj;
    return
end

sourceDir = expInfoObj.getPathName('source');
outputDir = expInfoObj.getPathName('output');
positionList = expInfo.getPositionList();

calibrationOffsetFile=fullfile('/home/spartak/PipelineInProd',EMCCD_offsetName);
fluoOffset=double(imread(calibrationOffsetFile)); % the average pixel offset, converted do double

offsetMin=min(fluoOffset(:));
cMax=-inf;
for posIdx = 1:length(positionList)
    currPos = positionList(posIdx);
    fluoDir = fullfile(sourceDir,currPos,fluoChanName);
    fluoList = dir(fullfile(fluoDir,'*.tif*'));
    imRangeFluo = expInfoObj.getRange(posName,fluoChanName);
    for fluoMovieIdx=1:length(imRangeFluo)
        currFluoMovieFile=fullfile(fluoDir,fluoList(fluoMovieIdx).name);
        % movie size
        FlInfo = imfinfo(currFluoMovieFile);
        nFrames= numel(FlInfo);

        MV=imread(currFluoMovieFile,1);  % first frame is usually brightest
        cMax=double(max(cMax,max(MV(:))-offsetMin));
        
        if nFrames > 1
            MV=imread(currFluoMovieFile,nFrames); % last frame is usually dimmest
            cMax=double(max(cMax,max(MV(:))-offsetMin));
        end
    end
end
logLobj = EMCCDfit.logL_EMCCD_lookup(EMgain,EMCCD_noiseStd,cMax,cMax/EMgain*3);
saveName = fullfile(outputDir,'logLobj.mat');
save(saveName,'logLobj','EMgain','EMCCD_noiseStd','cMax');