function outpath = ImAnalysis_setup(pipelinePath)
% Add paths that are needed to run ImAnalysis to the matlab path.
if ~nargin
    pipelinePath = '';
else
    dat = what(pipelinePath);
    if ~isempty(dat)
        pipelinePath = dat.path;
    end
end
curPipelinePath = fileparts(which('processCells.m'));
if isempty(curPipelinePath) && isempty(pipelinePath)
    error('ImAnalysis pipeline is not found');
end
if isempty(pipelinePath)
    pipelinePath = curPipelinePath;
end
if ~strcmp(curPipelinePath,pipelinePath) && ~isempty(pipelinePath) && ~isempty(curPipelinePath)
    disp(['Removing path to ' curPipelinePath]);
    rmpath(curPipelinePath)
    rmpath(genpath(fullfile(curPipelinePath,'Tools')));
    rmpath(fullfile(curPipelinePath,'uTrack'));
end
if ~exist(fullfile(pipelinePath,'processCells.m'),'file')
    error(['File processCells.m is not found in '  pipelinePath]);
end

addpath(pipelinePath);
addpath(genpath(fullfile(pipelinePath,'Tools')));
addpath(fullfile(pipelinePath,'uTrack'));
disp(['Set path to ' pipelinePath]);

if nargout==1
    outpath = pipelinePath;
end