"""<b>PerObjectEllipsefit</b> Object Feature based per object Gray-level Threshold using ellipse fit
<hr>
<b>PerObjectEllipsefit</b> produces a binary image
based on a per objectthreshold computed as the threshold level that optimized ellipse fit.

Parameters
==========
pixel_data: 2-D array of pixel values
area_interval_min: Smallest allowed object size (pixels)
area_interval_max: Largest allowed object size (pixels)
ellipsefit_thr: Smallest allowed ellipsefit value (between 0 and 1, 1 is perfect ellipse)
major_interval_min: Smallest allowed major axis length (pixels)
major_interval_max: Largest allowed major axis length (pixels)
minor_interval_min: Smallest allowed minor axis length (pixels)
minor_interval_max: Largest allowed minor axis length (pixels)
major_minor_ratio_interval_min: Smallest allowed major/minor axis ratio (pixels)
major_minor_ratio_interval_max: Largest allowed major/minor axis ratio (pixels)

by Petter Ranefall 2015
"""

import _perObjectEllipsefit as poe

class PerObjectEllipsefit(object):
       
    def run(self, pixel_data, area_interval_min, area_interval_max, ellipsefit_thr, major_interval_min, major_interval_max, minor_interval_min, minor_interval_max, major_minor_ratio_interval_min, major_minor_ratio_interval_max, thresholdwindow):
        return poe._perObjectEllipsefit(pixel_data, (area_interval_min, area_interval_max), ellipsefit_thr, (major_interval_min, major_interval_max), (minor_interval_min, minor_interval_max), (major_minor_ratio_interval_min, major_minor_ratio_interval_max), thresholdwindow)
