function [channelData] = getChannelData(imageDir,nChannels,channelLength,channelWidth)
% [channelData] = getChannelData(imageDir,nChannels,channelLength,channelWidth)
%
% Detect growth channels in already preprocessed images and store pixels 
% in their center

imageList = dir(fullfile(imageDir,'*.tif*'));
nFrames = numel(imageList);
hw = floor(channelWidth/2);
channelData = nan(channelLength,nFrames,nChannels);
parfor frIdx = 1:nFrames
    im = imread(fullfile(imageDir,imageList(frIdx).name));
    start = 1;
    for chIdx = 1:nChannels
        rowIdx = start + find(im(start:end,1),1) - 1;
        channelData(:,frIdx,chIdx) = double(im(rowIdx+hw,:));
        start = rowIdx + channelWidth;
    end
end