% Script is created by SZ for ML's data, 2017-12-05

outputDir =  '/home/samba/elflab/Projects/PRISM/analysis/by_eln_id/EXP-17-BO0423/segmentation/Output_Seg_Track/';
expInfoObj = loadExpInfo(outputDir);
positionList = expInfoObj.getPositionList();
nPositions = numel(positionList);

% The values below are possible to determine automatically but given
% manually for simplicity
channelLength = 651;
channelWidth = 27;
nChannels = 20;

channelData = cell(1,nPositions);
the_black = cell(1,nPositions);
the_white = cell(1,nPositions);
the_centroids = cell(1,nPositions);
for posIdx = 1:nPositions
    posName = positionList{posIdx};
    fprintf('Detecting relocalization for position %s', posName);

    imageDir =  fullfile(outputDir,posName,'PreprocessedPhase');
    tic
    channelData{posIdx} = ...
        getChannelData(imageDir,nChannels,channelLength,channelWidth);
    [the_black{posIdx},the_white{posIdx},the_centroids{posIdx}] = ...
        detectRecolonization(channelData{posIdx});
    toc
    
    f=figure(posIdx);
    f.Name = posName;
    
    subplot(2,1,1)
    boxplot(the_black{posIdx})
    title('black')

    
    subplot(2,1,2)    
    boxplot(the_white{posIdx})
    title('white')
    
end