function trajForAnalysis = trajFromOneMovie(mCells)
% This function extract trajectories from the ImAnalysis pipeline results
%
% Input:
%   mCells - array of MCell objects
%
% Output:
%   trajForAnalysis - cell array, where each cell is a matrix with rows
%                     [xcoord ycoord frame]
%
% Author: Vladimir Curic, 2015-01-21
%
% 2020-04-02, SZ: updated the code to make compatible with the latest
% version of the analysis pipeline.

trajList = [mCells.particles];
trajForAnalysis = cell(1,length(trajList));
for ii = 1:length(trajList)
    coord =  trajList.trajImageCoord;
    trajFirstFrame = trajList.firstFrame;
    trajLastFrame = trajFirstFrame+size(coord,1)-1;
    trajForAnalysis{ii} = [coord (trajFirstFrame:trajLastFrame)'];
end