function [] = classifyCellsLength(outputFolder,maxLengthTrajForPlot)
%%% This function plots trajectories in cells of certain sizes. This
%%% function plots internal coordinates into cells and the trajectories are
%%% color coded with respect to their real coordinates.
%
% Input:
%   - outputFolder : folder that contains the results
%   - maxLengthTrajForPlot
%   - OBS: this code will ask you to input how many classes of cell (with
%   respect to their length) would you like to consider and to input
%   corresponding boundaries
%
% Output:
%   - formal output are plot for each of the classes
%
% Author: Vladimir Curic, 2015-04-23

prompt = 'Please enter in how many classes you would like to divide your cells\n';
N = input(prompt);
minLength = zeros(1,N);
maxLength = zeros(1,N);

for ii = 1:N
    prompt = 'Please enter the minimal length of the cells\n';
    minLength(ii) = input(prompt);
    prompt = 'Please enter the maximal length of the cells\n';
    maxLength(ii) = input(prompt);
    if maxLength <= minLength
        fprintf('You enter the wrong boundaries! Please do it again!')
    end
end

%% Plot one by one with respect to cell sizes
for ii = 1:N
    
    counter = 0;
    positionList = dir(strcat(outputFolder,filesep,'Pos*'));

    for positionIdx = 1:length(positionList)
        disp(positionList(positionIdx).name)
        
        cellMatList = dir(strcat(outputFolder,filesep,positionList(positionIdx).name,filesep,'*.mat'));
        cellMatFile = load(strcat(outputFolder,filesep,positionList(positionIdx).name,filesep,cellMatList(1).name));
        fieldName = fieldnames(cellMatFile);
        cellStruct = cellMatFile.(fieldName{1});

       
        for jj = 1:length(cellStruct)
            if cellStruct(jj).cellLength >= minLength(ii) && cellStruct(jj).cellLength <= maxLength(ii)
                
                numberTempTrajectories = size(cellStruct(jj).particles,2);
                meanDispl = [];
                for kk = 1:numberTempTrajectories
                    tempVar = cellStruct(jj).particles;
                    tempTraj = tempVar(kk).trajImageCoord;
                    tempTrajInternal = tempVar(kk).trajInternalCoord;
                    meanDispl  = mean(sqrt((tempTraj(1:end-1,1)-tempTraj(2:end,1)).^2+(tempTraj(1:end-1,2)-tempTraj(2:end,2)).^2));
                    % Plot real coordinates
                    %plot(tempTraj(:,2),tempTraj(:,1),'-r');
                    %hold on
                    if size(tempTraj,1)<maxLengthTrajForPlot
                        counter = counter+1;
                        newStruct(counter).tempTraj = tempTraj;
                        newStruct(counter).trajInternal = tempTrajInternal;
                        newStruct(counter).meanDispl = meanDispl;
                    end
                end
            end
            
        end
    end
    
    [~, index] = sort([newStruct.meanDispl]);
    
    figure, h = plotCellOutline();
    for pp = 1:counter
        newIndex = index(pp);
        tempVarPlot = newStruct(newIndex).trajInternal;
        plot(tempVarPlot(:,2),tempVarPlot(:,1)*4,'color',[1 pp./counter 0]);
        %hold on
        %end
    end
    %axis([-1.2 1.2 -0.2 1.2])
    clearvars newStruct
    h = sprintf('Trajectories for cell length between %d and %d pixels', minLength(ii),maxLength(ii));
    title(h);
end


end

