function trajCut = cutTrajPipeline(inputTrajectory,minLength)
% This function cuts existing trajectory into smaller pieces of the minimal lenght minLength
%
% Input:
%   - inputTrajectory : trajectory that is considered
%   - minLength : the lenght of trajectory pieces
%
% Output:
%   - trajCut : cell array of all trajectory pieces
%
% Author: Vladimir Curic, 2014-11-14

number = 1;
trjSize = length(inputTrajectory);

if mod(trjSize,minLength) ~= 0
    
    trjSize = trjSize-mod(trjSize,minLength);
end

N = trjSize./minLength;

for jj = 1:N
    xTmp = inputTrajectory(minLength*jj-(minLength-1):minLength*jj,1);
    yTmp = inputTrajectory(minLength*jj-(minLength-1):minLength*jj,2);
    trajCut{number} = [xTmp yTmp];
    number = number+1;
end



end



