function [] = displayInternalDistribution(analysisFolder, nbLongBins, nbShortBins)
%% Parameters
minCellLength = 30;

%% Initialisation
posList = dir(strcat(analysisFolder,filesep,'pos*'));
indexOut = 1;

%% Data extraction
for posIdx = 1:length(posList)
    currPos = posList(posIdx).name;
    
    listMat = dir(strcat(analysisFolder,filesep,currPos,filesep,'*',currPos,'.mat'));
    cellFile = load(strcat(analysisFolder,filesep,currPos,filesep,listMat(1).name));
    fieldNames = fieldnames(cellFile);
    cellsArray = cellFile.(fieldNames{1});
    
    disp(['Processing cells in ' currPos])
    for ii = length(cellsArray):-1:1
        if ~isempty(cellsArray(ii).cellLength)
            currCell = cellsArray(ii);
            if currCell.cellLength > minCellLength && currCell.cellWidth > 0
                for jj = 1:length(currCell.particles)
                    currPart = currCell.particles(jj);
                    
                    for kk = 1:size(currPart.trajInternalCoord,1)
                        outArrayLong(indexOut) = currPart.trajInternalCoord(kk,1);
                        outArrayShort(indexOut) = currPart.trajInternalCoord(kk,2);
                        indexOut = indexOut+1;
                    end
                end
            end
        end
    end
end


%% Display
figure, hist(0.5-abs(0.5-outArrayLong), nbLongBins)
title('Distribution of dots along the long axis')
xlabel('Position along the long axis')

if nargin < 3
    return
end

figure, hist(abs(outArrayShort(abs(outArrayShort)<1.5)), nbShortBins)
title('Distribution of dots along the short axis')
xlabel('Position along the short axis')