function trajLength = histTrajLength(allTrajectories,nBins)
% This function computes the length of all trajectories
%
% Input : 
%   - allTrajectories :  trajectories 
%   - nBins : number of bins for plotting the histogram
%
% Output:
%   - trajLength: lenght of all trajectories
%   - figure diplaying the histogram of the trajectory lengths
%
% Author: Vladimir Curic, 2016-02-09

trajLength = [];
for ii = 1:length(allTrajectories)
   tempTraj = allTrajectories{1,ii};
   trajLength = [trajLength,length(tempTraj)]; 
end
figure, hist(trajLength,nBins)
end