function varargout = SegmentationCurator(varargin)
% SEGMENTATIONCURATOR MATLAB code for SegmentationCurator.fig
%      SEGMENTATIONCURATOR, by itself, creates a new SEGMENTATIONCURATOR or raises the existing
%      singleton*.
%
%      H = SEGMENTATIONCURATOR returns the handle to a new SEGMENTATIONCURATOR or the handle to
%      the existing singleton*.
%
%      SEGMENTATIONCURATOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SEGMENTATIONCURATOR.M with the given input arguments.
%
%      SEGMENTATIONCURATOR('Property','Value',...) creates a new SEGMENTATIONCURATOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SegmentationCurator_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SegmentationCurator_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help SegmentationCurator

% Last Modified by GUIDE v2.5 21-Nov-2018 16:20:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SegmentationCurator_OpeningFcn, ...
                   'gui_OutputFcn',  @SegmentationCurator_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SegmentationCurator is made visible.
function SegmentationCurator_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SegmentationCurator (see VARARGIN)

% Choose default command line output for SegmentationCurator
handles.output = hObject;
handles.imagefile = 'img_000000000.tiff';
handles = getParameters(handles);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes SegmentationCurator wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SegmentationCurator_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in load_expinfo_button.
function load_expinfo_button_Callback(hObject, eventdata, handles)
% hObject    handle to load_expinfo_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname, filterindex] = uigetfile();
if ~filterindex
    return
end

handles.expInfoObj = loadExpInfo(pathname, filename);

if handles.expInfoObj.getParameters('doSegmentation') ~= 2
    errordlg('Phase images must be segmented');
end

set(handles.datapath_text,'String',fullfile(pathname,filename));
% phaseChanName = handles.expInfoObj.getChannelNames('phase');
posName = handles.expInfoObj.getPositionList(1);
nPhaseFrames = length(dir(fullfile(pathname,posName,'PreprocessedPhase','*.tif*')));
phaseListStr = cell(1,nPhaseFrames);
for i=1:nPhaseFrames
    phaseListStr{i} = num2str(i);
end
set(handles.phase_frame_popup,'String',phaseListStr);
set(handles.phase_frame_popup,'Value',1);
positionList = handles.expInfoObj.getPositionList();
set(handles.position_popup,'String',positionList);
handles.phase.frame = 1;
% Get cytox channel
sourceDir = handles.expInfoObj.getPathName('source');
chanList = dir(fullfile(sourceDir,posName));
chanList(1:2) = [];
chanList = chanList([chanList.isdir]);
chanNames = handles.expInfoObj.getChannelNames();
if numel(chanList)~=4 || numel(chanNames)~=3
    handles.cytoxChanName = '';
else
    for i=1:numel(chanList)
        if ~any(strcmp(chanList(i).name,chanNames))
            handles.cytoxChanName = chanList(i).name;
            break
        end
    end
end
% Load images
handles = moveToPosition(handles, 1);
if get(handles.manual_select_button,'Value')
    manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
end

guidata(hObject, handles);


% --- Executes on button press in backward_button.
function backward_button_Callback(hObject, eventdata, handles)
% hObject    handle to backward_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
posIdx = str2double(get(handles.position_edit,'String'));
maxPosIdx = numel(handles.expInfoObj.getPositionList());
if posIdx > 1
    posIdx = posIdx-1;
else
    posIdx = maxPosIdx;
end
handles = moveToPosition(handles, posIdx);
if get(handles.manual_select_button,'Value')
    manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
end
guidata(hObject,handles);

% --- Executes on button press in forward_button.
function forward_button_Callback(hObject, eventdata, handles)
% hObject    handle to forward_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
posIdx = str2double(get(handles.position_edit,'String'));
maxPosIdx = numel(handles.expInfoObj.getPositionList());
if posIdx < maxPosIdx
    posIdx = posIdx+1;
else
    posIdx = 1;
end
handles = moveToPosition(handles, posIdx);
if get(handles.manual_select_button,'Value')
    manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
end
guidata(hObject,handles);




% % --- Executes on button press in goto_button.
% function goto_button_Callback(hObject, eventdata, handles)
% % hObject    handle to goto_button (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% posIdx = str2double(get(handles.position_edit,'String'));
% maxPosIdx = numel(handles.expInfoObj.getPositionList());
% if isempty(posIdx) || posIdx > maxPosIdx || posIdx<0
%     errordlg(sprintf('Choose position index between 1 and %d',maxPosIdx));
% end
% handles = moveToPosition(posIdx,handles);
% guidata(hObject,handles);

function position_edit_Callback(hObject, eventdata, handles)
% hObject    handle to position_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
posIdx = str2double(get(hObject,'String'));
maxPosIdx = numel(handles.expInfoObj.getPositionList());
if posIdx > maxPosIdx || posIdx < 1
    fig = errordlg(sprintf('Choose position index between 1 and %d', maxPosIdx));
    uiwait(fig);
    uicontrol(hObject);
    return;
end
handles = moveToPosition(handles, posIdx);
if get(handles.manual_select_button,'Value')
    manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
end
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function position_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to position_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in runsave_button.
function runsave_button_Callback(hObject, eventdata, handles)
% hObject    handle to runsave_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
outputDir = handles.expInfoObj.getPathName('output');
positionList = handles.expInfoObj.getPositionList();
nPositions = numel(positionList);

f = waitbar(0,'Creating backup files','CreateCancelBtn','setappdata(gcbf,''canceling'',1)');
setappdata(f,'canceling',0);
for posIdx = 1:nPositions
    if getappdata(f,'canceling')
        break
    end
    waitbar((posIdx-1)/nPositions/2, f,'Creating backup files');
    posName = positionList{posIdx};
    segDir = fullfile(outputDir,posName,'SegmentedPhase');
    backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
    if ~exist(backDir,'dir')
        mkdir(backDir)
        copyfile(segDir,backDir);
    end
    rmdir(segDir,'s');
    mkdir(segDir);
end
phaseListIdx = get(handles.phase_frame_popup,'Value');
for posIdx = 1:nPositions
    if getappdata(f,'canceling')
        break
    end
    waitbar(0.5+(posIdx-1)/nPositions/2, f,'Curating segmented images');
    % Read image
    handles = moveToPosition(handles, posIdx, 0);
    posName = positionList{posIdx};

    segIm = handles.segIm;
    isBad = handles.cells.isBad;
    for i=1:numel(handles.cells.labels)
        cellLabel = handles.cells.labels(i);
        if any(isBad(i,:))
           segIm(segIm==cellLabel) = 0;
        end
    end
    
    segDir = fullfile(outputDir,posName,'SegmentedPhase');
    backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
    backList = dir(fullfile(backDir,'*.tif*'));
    imFileName = backList(phaseListIdx).name;
    
    imwrite(segIm,fullfile(segDir,imFileName));    
end
waitbar(1,f,'Done');
delete(f);
currPosIdx = str2double(get(handles.position_edit,'String'));
handles = moveToPosition(handles, currPosIdx);
if get(handles.manual_select_button,'Value')
    saveParameters(handles)
end
guidata(hObject, handles);


function fluo2_bg_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_bg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fluo2_bg as text
%        str2double(get(hObject,'String')) returns contents of fluo2_bg as a double
val = getProperty(hObject,[],1,1,1);
if ~val
    val = [];
end
if isequal(handles.fluo2.bg,val)
    return
end
handles.fluo2.bg = val;
handles = filterCellsByFluo2(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function fluo2_bg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo2_bg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fluo2_upp_thresh_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_upp_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,Inf,1,0,1);
if ~status
    return
end
if isequal(handles.fluo2.uppThresh, val)
    return
end
handles.fluo2.uppThresh = val;
handles = filterCellsByFluo2(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function fluo2_upp_thresh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo2_upp_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fluo1_frames_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_frames (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
frameRange = getFrameRange(handles);
currFrameRange = handles.fluo1.frameRange;
if isequal(currFrameRange, frameRange)
    return
end
handles.fluo1.frameRange = frameRange;
handles = computeFluoAVG(handles);
handles.cells.fluo1 = computeCellFluorescence(handles.fluo1.im,handles);
set(handles.fluo1_bkg_value_text,'String', handles.cells.fluo1.bg);
handles = filterCellsByFluo1(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
% plotCells(handles.fluo1_axes,handles.cells.boundaries,handles.cells.isBad(:,2),handles.T);
guidata(hObject,handles);

function frameRange = getFrameRange(handles)
val = str2num(get(handles.fluo1_frames,'String'));
if length(val) == 2
    frameRange = min(val):max(val);
elseif length(val) == 1
    frameRange = val;
elseif isempty(val)
    frameRange = [];%1:numel(handles.fluo1.imfinfo);
else
    errordlg(sprintf('Define frame range by min and max frames, or leave empty'));
    return
end


% --- Executes during object creation, after setting all properties.
function fluo1_frames_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_frames (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function fluo1_bg_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_bg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% if handles.fluo1.lowThresh 
val = getProperty(hObject,[],1,0,1);
if ~val
    val = [];
end
currBg = handles.fluo1.bg;
if isequal(val,currBg)
    return
end
handles.fluo1.bg = val;
handles = filterCellsByFluo1(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function fluo1_bg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_bg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fluo1_low_thresh_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_low_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,0,1,0,1);
if ~status
    return
end
if isequal(handles.fluo1.lowThresh, val)
    return
end
handles.fluo1.lowThresh = val;
handles = filterCellsByFluo1(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function fluo1_low_thresh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_low_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in fluo1_filter_checkbox.
function fluo1_filter_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_filter_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value')
    handles = filterCellsByFluo1(handles);
else
    % restore segmentation
    handles.cells.isBad(:,1) = 0;
end
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);


function fluo1_upp_thresh_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_upp_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,Inf,1,0,1);
if ~status
    return
end
if isequal(handles.fluo1.uppThresh,val)
    return
end
handles.fluo1.uppThresh = val;
handles = filterCellsByFluo1(handles);
handles = filterCellsByNumber(handles);
plotCellsWrapper(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function fluo1_upp_thresh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_upp_thresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function seg_dilate_Callback(hObject, eventdata, handles)
% hObject    handle to seg_dilate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,0,1,1,0);
if ~status
    return
end
if handles.dilationRadius == val
    return
end
handles.dilationRadius = val;
handles = postprocessSegmentedImage(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function seg_dilate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to seg_dilate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function seg_shift_Callback(hObject, eventdata, handles)
% hObject    handle to seg_shift (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,[0 0],2,0,0);
if ~status
    return
end
if isequal(handles.shiftVector, val)
    return
end
handles.shiftVector = val;
handles = postprocessSegmentedImage(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function seg_shift_CreateFcn(hObject, eventdata, handles)
% hObject    handle to seg_shift (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function seg_rotate_Callback(hObject, eventdata, handles)
% hObject    handle to seg_rotate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[val, status] = getProperty(hObject,0,1,0,0);
if ~status
    return
end
if handles.rotationAngle == val
    return
end
handles.rotationAngle = val;
handles = postprocessSegmentedImage(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function seg_rotate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to seg_rotate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function seg_max_cells_Callback(hObject, eventdata, handles)
% hObject    handle to seg_max_cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[maxNumOfCells, status] = getProperty(hObject,[2 8],2,1,1);
if ~status
    return
end
if handles.maxNumOfCells(1) ~= maxNumOfCells(1) || handles.maxNumOfCells(2) ~= maxNumOfCells(2) 
    handles.maxNumOfCells = maxNumOfCells;
    handles = postprocessSegmentedImage(handles);
end
guidata(hObject,handles);
% Hints: get(hObject,'String') returns contents of seg_max_cells as text
%        str2double(get(hObject,'String')) returns contents of seg_max_cells as a double


% --- Executes during object creation, after setting all properties.
function seg_max_cells_CreateFcn(hObject, eventdata, handles)
% hObject    handle to seg_max_cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Custom functions
function handles = displayPhaseAndBfImages(handles, posIdx, makePlots)
sourceDir = handles.expInfoObj.getPathName('source');
outputDir = handles.expInfoObj.getPathName('output');
posName = handles.expInfoObj.getPositionList(posIdx);

phaseDir = fullfile(outputDir,posName,'PreprocessedPhase');
phaseList = dir(fullfile(phaseDir,'*.tif*'));
phaseListIdx = get(handles.phase_frame_popup,'Value');
handles.phase.im = imread(fullfile(phaseDir,phaseList(phaseListIdx).name));

bfChanNames = handles.expInfoObj.getChannelNames('bf');
handles.bf.im = imread(fullfile(sourceDir,posName,bfChanNames{1},handles.imagefile));

if makePlots
    plotImage(handles.phase_axes,handles.phase.im);
    setClim(handles,'phase');
    plotImage(handles.bf_axes,handles.bf.im);
    setClim(handles,'bf');
end

function handles = readSegmentedImage(handles, posIdx)
outputDir = handles.expInfoObj.getPathName('output');
posName = handles.expInfoObj.getPositionList(posIdx);
backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
savedSegDir = fullfile(outputDir,posName,'SegmentedPhase');
savedSegList = dir(fullfile(savedSegDir,'*.tif*'));
if exist(backDir,'dir') &&  length(savedSegList) == 1
    segDir = backDir;
    set(handles.status_text_value,'String','saved');
    savedSegIm = imread(fullfile(savedSegDir,savedSegList(1).name));
    cellBoundaries = bwboundaries(savedSegIm,'noholes');
%     T = handles.T;
    for i=1:length(cellBoundaries)
         cellBoundaries{i} = cellBoundaries{i}(:,[2 1]);
%         cellBoundaries{i} = convertFromPhase(cellBoundaries{i}(:,[2 1]),T);
    end
    handles.savedCellBoundaries = cellBoundaries;
else
    segDir = fullfile(outputDir,posName,'SegmentedPhase');
    set(handles.status_text_value,'String','not saved');
    handles.savedCellBoundaries = [];
end
if exist(backDir,'dir')
    segDir = backDir;
end
segList = dir(fullfile(segDir,'*.tif*'));
phaseListIdx = get(handles.phase_frame_popup,'Value');
handles.segIm = imread(fullfile(segDir,segList(phaseListIdx).name));
handles.origSegIm = handles.segIm;

function handles = getCells(handles, makePlots)
if nargin == 1
    makePlots = 1;
end
segIm = handles.segIm;
cellBoundaries = bwboundaries(segIm,'noholes');
cellLabels = nan(size(cellBoundaries));
cellAreas = nan(size(cellBoundaries));
for i = 1:length(cellBoundaries)
    cellBoundaries{i} = cellBoundaries{i}(:,[2 1]);
    cellLabels(i) = segIm(cellBoundaries{i}(1,2),cellBoundaries{i}(1,1));
    cellAreas(i) = sum(sum( segIm==cellLabels(i) ));
end
handles.cells.boundaries = cellBoundaries;
handles.cells.labels = cellLabels;
handles.cells.areas = cellAreas;
handles.cells.isBad = zeros(length(cellBoundaries),4);
handles.cells.fluo1 = computeCellFluorescence(handles.fluo1.im,handles);
if ~isempty(handles.cytoxChanName)
    handles.cells.fluo2 = computeCellFluorescence(handles.fluo2.im,handles);
end
if makePlots
    set(handles.fluo1_bkg_value_text,'String', handles.cells.fluo1.bg);
    if ~isempty(handles.cytoxChanName)
        set(handles.fluo2_bkg_value_text,'String', handles.cells.fluo2.bg);
    end
end
handles = filterCellsByFluo1(handles);
handles = filterCellsByFluo2(handles);


function [convertedCoord] = convertFromPhase(coord, T)
if ~isa(coord,'float')
    coord = double(coord);
end
convertedCoord = [coord ones(length(coord),1)]/T;
convertedCoord = convertedCoord(:,1:2);


function plotImage(ax,im)
imagePlotHandle = findobj(ax,'Type','Image');
if ~isempty(imagePlotHandle)
    delete(imagePlotHandle);
end
hold(ax,'on')
imagesc(ax,im);
axis(ax,'image') 
colormap(ax,'gray')
set(ax,'Ydir','reverse','YTick',[],'XTick',[]);
hold(ax,'off')
ax.Children = ax.Children([2:end 1]);


function handles = computeFluoAVG(handles, makePlots)
if nargin == 1
    makePlots = 1;
end
imagePath = handles.fluo1.imagepath;
imfInfo = handles.fluo1.imfinfo;
frameRange = handles.fluo1.frameRange;
if isempty(frameRange)
    frameRange = 1:numel(imfInfo);
end
maxFrame = numel(handles.fluo1.imfinfo);
if max(frameRange) > maxFrame
    errordlg(sprintf('Choose frame range between 1 and %d',maxFrame));
    return
end
avgIm = zeros(imfInfo(1).Height,imfInfo(1).Width);
for i=1:numel(frameRange)
    frameIm = double(imread(imagePath,frameRange(i),'Info',imfInfo));
    avgIm = avgIm+frameIm;
end
avgIm = uint16(avgIm/numel(frameRange));
handles.fluo1.im = avgIm;
if makePlots
    plotImage(handles.fluo1_axes,avgIm);
    plotImage(handles.fluo1_axes_duplicate,avgIm);
    setClim(handles,'fluo1');
end


function handles = filterCellsByFluo1(handles)
if ~get(handles.fluo1_filter_checkbox,'Value')
    return
end
% get AVG thresholds
bgFluo1 = handles.fluo1.bg;
lowThreshFactor = handles.fluo1.lowThresh;
if ~isempty(lowThreshFactor)
    if ~isempty(bgFluo1)
        lowThresh = lowThreshFactor * bgFluo1;
    else
        h = errordlg('Missing background information');
        uiwait(h);
        uicontrol(handles.fluo1_bg);
        return
    end
else
    lowThresh = 0;
end
uppThreshFactor = handles.fluo1.uppThresh;
avgCellIntensity = mean(handles.fluo1.im(handles.cells.fluo1.mask>0));
uppThresh = uppThreshFactor * avgCellIntensity;
isBadCell = zeros(size(handles.cells.isBad,1),1);
cellFluo = handles.cells.fluo1.val;
isBadCell(cellFluo<lowThresh | cellFluo>uppThresh) = 1;
handles.cells.isBad(:,1) = isBadCell;

function handles = filterCellsByFluo2(handles)
if isempty(handles.cytoxChanName) || ~get(handles.fluo2_filter_checkbox,'Value')
    return
end
bg = handles.fluo2.bg;
if isempty(bg)
    h = errordlg('Missing background information');
    uiwait(h);
    uicontrol(handles.fluo2_bg);
    return
end
uppThreshFactor = handles.fluo2.uppThresh;
if ~uppThreshFactor
    h = errordlg('Missing upper threshold');
    uiwait(h);
    uicontrol(handles.fluo2_upp_thresh);
    return
end
uppThresh = uppThreshFactor*bg;
isBadCell = zeros(size(handles.cells.isBad,1),1);
cellFluo = handles.cells.fluo2.val;
isBadCell( cellFluo > uppThresh ) = 1;
handles.cells.isBad(:,2) = isBadCell;


function handles = displayFluo2(handles, posIdx, makePlots)
if isempty(handles.cytoxChanName)
    return
end
sourceDir = handles.expInfoObj.getPathName('source');
posName = handles.expInfoObj.getPositionList(posIdx);
% chanList = dir(fullfile(sourceDir,posName));
% chanList(1:2) = [];
% chanList = chanList([chanList.isdir]);
% chanNames = handles.expInfoObj.getChannelNames();
% if numel(chanList)~=4 || numel(chanNames)~=3
%     handles.cytoxChanName = '';
%     return
% end
% for i=1:numel(chanList)
%     if ~any(strcmp(chanList(i).name,chanNames))
%         handles.cytoxChanName = chanList(i).name;
%         break
%     end
% end
imPath = fullfile(sourceDir,posName,handles.cytoxChanName,handles.imagefile);
handles.fluo2.im = imread(imPath);
if makePlots
    plotImage(handles.fluo2_axes,handles.fluo2.im)
    setClim(handles,'fluo2');
end


function plotCellsWrapper(handles)
plotCells(handles.phase_axes, handles.cells.boundaries, handles.cells.isBad, []);
plotCells(handles.bf_axes, handles.cells.boundaries, handles.cells.isBad, handles.Tbf);
plotCells(handles.fluo1_axes, handles.cells.boundaries, handles.cells.isBad(:,1), handles.T);
plotCells(handles.fluo2_axes, handles.cells.boundaries, handles.cells.isBad(:,2), handles.T);
% imSize = size(handles.fluo1.im);
% cellFluo1 = getCellFluoMask(handles.cells.boundaries,handles.T,imSize,handles.cells.fluo1);
% cellFluo2 = getCellFluoMask(handles.cells.boundaries,handles.T,imSize,handles.cells.fluo2);

dcm = datacursormode(handles.figure1);
set(dcm, 'UpdateFcn', @datatipOnFluoIm);

% set(dcm, 'UpdateFcn', {@datatip_callback, handles.cells.fluo1.mask, handles.cells.fluo2.mask});

% function cellMask = getCellFluoMask(cellBoundaries,T,imSize,cellFluo)
% cellMask = zeros(imSize);
% for i=1:length(cellBoundaries)
%     bb = cellBoundaries{i};
%     bb = convertFromPhase(bb,T);
%     rbb = round(bb);
%     if any(rbb(:)<1) || any(rbb(:,1)>imSize(2)) || any(rbb(:,2)>imSize(1))
%         continue
%     end
%     cellMask(sub2ind(imSize,rbb(:,2),rbb(:,1))) = cellFluo(i);
% end
% cellMask = imfill(cellMask);
% cellMask(cellMask==0) = mean(cellMask(cellMask==0));

function plotCells(ax,cellBoundaries,isBad,T)
if isempty(ax.Children)
    return
end
% Delete old cells
cellPlotHandles = findobj(ax,'Type','Line');
for i=1:length(cellPlotHandles)
    delete(cellPlotHandles(i));
end
if isempty(isBad)
    isBad = zeros(length(cellBoundaries),1);
end
if ~isempty(T)
    % find image size
    im = ax.Children(1).CData;
    imSize = size(im);
end
% Plot new cells
hold(ax,'on')
for i=1:length(cellBoundaries)
    bb = cellBoundaries{i};
    outOfBorder = false;
    if ~isempty(T)
        bb = convertFromPhase(bb,T);
        rbb = round(bb);
        outIndex = any(rbb<1,2) | rbb(:,1)>imSize(2) | rbb(:,2)>imSize(1);
        if any(outIndex)
            outOfBorder = true;
            bb(outIndex,:) = [];
        end
    end
    if size(isBad,2)==1
        isInactive = isBad(i);
    else
        isInactive = isBad(i,4)>=0 && any(isBad(i,:))>0;
    end
    if isInactive || outOfBorder == true
        lineStyle = 'r-';
    else
        lineStyle = 'g-';
    end
    if ~isempty(bb)
        plot(ax,bb(:,1),bb(:,2),lineStyle);
    end
end
hold(ax,'off');

function outtxt = datatipOnFluoIm(hObject,eventObj, varargin)
handles = guidata(hObject);
fluoMask1 = handles.cells.fluo1.mask;
fluoMask2 = handles.cells.fluo2.mask;
coord = round(get(eventObj,'Position'));
axTag = eventObj.Target.Parent.Tag;
if strcmp(axTag,'fluo1_axes')
    outtxt = sprintf('%.0f', fluoMask1(coord(2),coord(1)));
elseif strcmp(axTag,'fluo2_axes')
    outtxt = sprintf('%.0f', fluoMask2(coord(2),coord(1)));
else
    outtxt = sprintf('X:%d, Y:%d', coord(1),coord(2));
end


function handles = readFluo1(handles, posIdx)
sourceDir = handles.expInfoObj.getPathName('source');
posName = handles.expInfoObj.getPositionList(posIdx);
fluoChanNames = handles.expInfoObj.getChannelNames('fluo');
handles.fluo1.imagepath = fullfile(sourceDir,posName,fluoChanNames{1},handles.imagefile);
handles.fluo1.imfinfo = imfinfo(handles.fluo1.imagepath);


function outStruct = computeCellFluorescence(fluoIm, handles)
invT = inv(handles.T);
invT(:,3) = [0;0;1];
tform = affine2d(invT);
R = imref2d(size(fluoIm));
fluoVal = nan(size(handles.cells.boundaries));
fluoMask = zeros(size(fluoIm));
for i=1:numel(handles.cells.boundaries)
    cellIm = handles.segIm == handles.cells.labels(i);
    transCellIm = imwarp(cellIm,tform,'outputView',R,'FillValues',0);
    area = sum(sum(transCellIm));
    sumIntensity = sum(fluoIm(transCellIm));
    fluoVal(i) = sumIntensity / area;
    fluoMask(transCellIm) = fluoVal(i);
end
fluoMask = imfill(fluoMask);
bg = round(mean(fluoIm(~fluoMask)));
% fluoMask(~fluoMask) = bg;
outStruct.bg = bg;
outStruct.val = fluoVal;
outStruct.mask = fluoMask;


function handles = moveToPosition(handles, posIdx, makePlots)
if nargin == 2
    makePlots = 1;
end
if makePlots
%     set(handles.manual_select_button,'String','Off','Value',0);
    set(handles.position_edit,'String',num2str(posIdx));
%     posName = handles.expInfoObj.getPositionList(posIdx);
    set(handles.position_popup,'Value',posIdx);
    % Clear existing plots
    cla(handles.phase_axes);
    cla(handles.bf_axes);
    cla(handles.fluo1_axes);
    cla(handles.fluo1_axes_duplicate);
    cla(handles.fluo2_axes);
end

posName = handles.expInfoObj.getPositionList(posIdx);
fluoChanNames = handles.expInfoObj.getChannelNames('fluo');
bfChanNames = handles.expInfoObj.getChannelNames('bf');
handles.T = handles.expInfoObj.getTByFrame(posName,1,fluoChanNames{1});
handles.Tbf = handles.expInfoObj.getTByFrame(posName,1,bfChanNames{1});

handles = displayPhaseAndBfImages(handles, posIdx, makePlots);
handles = readFluo1(handles, posIdx);
handles = computeFluoAVG(handles, makePlots);
handles = displayFluo2(handles, posIdx, makePlots);
handles = readSegmentedImage(handles, posIdx);
handles = postprocessSegmentedImage(handles, makePlots);
plotCells(handles.fluo1_axes_duplicate, handles.savedCellBoundaries, [], handles.T);


function handles = dilateSegmentedImage(handles)
if handles.dilationRadius >0
    se = strel('disk',handles.dilationRadius);
    im = handles.origSegIm;
    dilIm = imdilate(handles.origSegIm,se);
    segIm = dilIm;
    blobLabels = unique(im(im>0));
    for i=1:length(blobLabels)
        blobLabel = blobLabels(i);
        blobMask = dilIm == blobLabel;
        boundaryMask = boundarymask(blobMask, 8);
        segIm(boundaryMask & dilIm>0 & dilIm~= blobLabel) = 0;
    end
    handles.segIm = segIm;
elseif handles.dilationRadius < 0
    se = strel('disk',-handles.dilationRadius);
    handles.segIm = imerode(handles.origSegIm,se);
else
    handles.segIm = handles.origSegIm;
end

function handles = shiftSegmentedImage(handles)
if any(handles.shiftVector) 
    handles.segIm = imtranslate(handles.segIm,handles.shiftVector);
end

function handles = rotateSegmentedImage(handles)
if handles.rotationAngle
    rotIm = imrotate(handles.segIm>0,handles.rotationAngle,'bilinear','crop');
%     cellLabels = [0; handles.cells.labels];
%     for i=1:numel(rotIm)
%         [~, idx] = min(dist(rotIm(i),cellLabels));
%         rotIm(i) = cellLabels(idx);
%     end
    rotSegIm = uint16(zeros(size(rotIm)));
    [~, L, N] = bwboundaries(rotIm,'noholes');
    for i=1:N
        rotSegIm(L==i) = i;
    end
    handles.segIm = rotSegIm;
end

function handles = filterCellsByBorder(handles)
cellBoundaries = handles.cells.boundaries;
T = handles.T;
isBad = handles.cells.isBad;
imSize = size(handles.fluo1.im);
for i=1:length(cellBoundaries)
    bb = cellBoundaries{i};
    bb = convertFromPhase(bb,T);
    rbb = round(bb);
    if any(rbb(:)<1) || any(rbb(:,1)>imSize(2)) || any(rbb(:,2)>imSize(1))
        isBad(i,3) = 1;
    end
end
handles.cells.isBad = isBad;

function handles = filterCellsByNumber(handles)
numGoodCells = sum(all(~handles.cells.isBad(:,1:3),2));
if numGoodCells >= handles.maxNumOfCells(1) && numGoodCells <= handles.maxNumOfCells(2) 
    handles.cells.isBad(:,4) = 0;
else
    handles.cells.isBad(:,4) = 1;
end

function handles = postprocessSegmentedImage(handles, makePlots)
if nargin == 1
    makePlots = 1;
end
handles = dilateSegmentedImage(handles);
handles = shiftSegmentedImage(handles);
handles = rotateSegmentedImage(handles);
handles = getCells(handles, makePlots);
handles = filterCellsByBorder(handles);
handles = filterCellsByNumber(handles);
if makePlots
    plotCellsWrapper(handles);
end


function [property, status] = getProperty(h, defaultValue, arrayLen, isInteger, isPositive)
propertyText = get(h,'String');
status = 1;
if isempty(propertyText)
    property = defaultValue;
    return
elseif arrayLen == 1
    property = str2double(propertyText);
else
    property = str2num(propertyText);
end
% validate data
% if ~any(property)
%     property = [];
%     return
% end
errMsg = sprintf('Enter %d', arrayLen);
if length(property) ~= arrayLen
    status = 0;
end
if isPositive && ~all(property >= 0)
    status = 0;
    errMsg = [errMsg ' nonnegative'];
end
if isInteger && ~all(round(property) == property)
    status = 0;
    errMsg = [errMsg ' integer'];
end
if status && any(isnan(property))
    status = 0;
    errMsg = [errMsg ' numeric'];
end
if ~status
    errMsg = [errMsg ' value(s)'];
    % display error message
    f = errordlg(errMsg);
    uiwait(f);
    uicontrol(h);
end



% function phase_index_Callback(hObject, eventdata, handles)
% % hObject    handle to phase_index (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% [~, status] = getProperty(hObject,1,1,1,1);
% if status
%     posIdx = str2double(get(handles.position_edit,'String'));
%     handles = moveToPosition(posIdx,handles);
% end
% guidata(hObject, handles);
% % Hints: get(hObject,'String') returns contents of phase_index as text
% %        str2double(get(hObject,'String')) returns contents of phase_index as a double
% 
% 
% % --- Executes during object creation, after setting all properties.
% function phase_index_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to phase_index (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called
% 
% % Hint: edit controls usually have a white background on Windows.
% %       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end


% --- Executes on button press in fluo1_clim_auto.
function fluo1_clim_auto_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_clim_auto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% set(handles.fluo1_axes,'CLimMode','auto');
set(handles.fluo1_min_clim,'String','0.01');
set(handles.fluo1_max_clim,'String','0.99');
setClim(handles,'fluo1');


function fluo1_min_clim_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[~, status] = getProperty(hObject,0,1,0,1);
if ~status
    return
end
setClim(handles,'fluo1');


% --- Executes during object creation, after setting all properties.
function fluo1_min_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function fluo1_max_clim_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[maxClim, status] = getProperty(hObject,1,1,0,1);
if ~status
    return
end
if maxClim>1
    h = errordlg('Clim value must be <= 1');
    uiwait(h);
    return
end
setClim(handles,'fluo1');


% --- Executes during object creation, after setting all properties.
function fluo1_max_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo1_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in fluo2_filter_checkbox.
function fluo2_filter_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_filter_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value')
    handles = filterCellsByFluo2(handles);
else
    % restore segmentation
    handles.cells.isBad(:,2) = 0;
end
plotCellsWrapper(handles);
guidata(hObject,handles);


function setClim(handles,id)
the_clim = [];
switch id
    case 'phase'
        minClim = str2double(get(handles.phase_min_clim,'String'));
        maxClim = str2double(get(handles.phase_max_clim,'String'));
        im = handles.phase.im;
        ax = handles.phase_axes;
    case 'bf'
        minClim = str2double(get(handles.bf_min_clim,'String'));
        maxClim = str2double(get(handles.bf_max_clim,'String'));
        im = handles.bf.im;
        ax = handles.bf_axes;
    case 'fluo1'
        if get(handles.fluo1_fix_button,'Value')
            the_clim = handles.fluo1.clim;
        else
            minClim = str2double(get(handles.fluo1_min_clim,'String'));
            maxClim = str2double(get(handles.fluo1_max_clim,'String'));
        end
        im = handles.fluo1.im;
        ax = handles.fluo1_axes;
    case 'fluo2'
        if get(handles.fluo2_fix_button,'Value')
            the_clim = handles.fluo2.clim;
        else
            minClim = str2double(get(handles.fluo2_min_clim,'String'));
            maxClim = str2double(get(handles.fluo2_max_clim,'String'));
        end
        im = handles.fluo2.im;
        ax = handles.fluo2_axes;
end
if isempty(the_clim)
    the_clim = quantile(double(im(:)),[minClim maxClim]);
end
set(ax,'CLim',the_clim);
if strcmp(id, 'fluo1')
    set(handles.fluo1_axes_duplicate,'CLim',the_clim);
end


% --- Executes on button press in fluo2_clim_auto.
function fluo2_clim_auto_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_clim_auto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.fluo2_min_clim,'String','0.01');
set(handles.fluo2_max_clim,'String','0.99');
setClim(handles,'fluo2');


function fluo2_min_clim_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[~, status] = getProperty(hObject,0,1,0,1);
if ~status
    return
end
setClim(handles,'fluo2');


% --- Executes during object creation, after setting all properties.
function fluo2_min_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo2_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fluo2_max_clim_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[maxClim, status] = getProperty(hObject,1,1,0,1);
if ~status
    return
end
if maxClim>1
    h = errordlg('Clim value must be <= 1');
    uiwait(h);
    return
end
setClim(handles,'fluo2');


% --- Executes during object creation, after setting all properties.
function fluo2_max_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fluo2_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in bf_clim_auto.
function bf_clim_auto_Callback(hObject, eventdata, handles)
% hObject    handle to bf_clim_auto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.bf_min_clim,'String','0.01');
set(handles.bf_max_clim,'String','0.99');
setClim(handles,'bf');


function bf_min_clim_Callback(hObject, eventdata, handles)
% hObject    handle to bf_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[~, status] = getProperty(hObject,0,1,0,1);
if ~status
    return
end
setClim(handles,'bf');

% --- Executes during object creation, after setting all properties.
function bf_min_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to bf_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function bf_max_clim_Callback(hObject, eventdata, handles)
% hObject    handle to bf_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[maxClim, status] = getProperty(hObject,1,1,0,1);
if ~status
    return
end
if maxClim>1
    errordlg('Clim value must be <= 1');
    return
end
setClim(handles,'bf');


% --- Executes during object creation, after setting all properties.
function bf_max_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to bf_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in phase_clim_auto.
function phase_clim_auto_Callback(hObject, eventdata, handles)
% hObject    handle to phase_clim_auto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.phase_min_clim,'String','0.01');
set(handles.phase_max_clim,'String','0.99');
setClim(handles,'phase');


function phase_min_clim_Callback(hObject, eventdata, handles)
% hObject    handle to phase_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[~, status] = getProperty(hObject,0,1,0,1);
if ~status
    return
end
setClim(handles,'phase');


% --- Executes during object creation, after setting all properties.
function phase_min_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phase_min_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function phase_max_clim_Callback(hObject, eventdata, handles)
% hObject    handle to phase_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[maxClim, status] = getProperty(hObject,1,1,0,1);
if ~status
    return
end
if maxClim>1
    errordlg('Clim value must be <= 1');
    return
end
setClim(handles,'phase');


% --- Executes during object creation, after setting all properties.
function phase_max_clim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phase_max_clim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in phase_frame_popup.
function phase_frame_popup_Callback(hObject, eventdata, handles)
% hObject    handle to phase_frame_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val = get(hObject,'Value');
if val ~= handles.phase.frame
    handles.phase.frame = val;
    posIdx = str2double(get(handles.position_edit,'String'));
    handles = moveToPosition(handles, posIdx);
    if get(handles.manual_select_button,'Value')
        manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
    end
end
guidata(hObject, handles);
% Hints: contents = cellstr(get(hObject,'String')) returns phase_frame_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from phase_frame_popup


% --- Executes during object creation, after setting all properties.
function phase_frame_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phase_frame_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in load_param_button.
function load_param_button_Callback(hObject, eventdata, handles)
% hObject    handle to load_param_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname, filterindex] = uigetfile('*.txt');
if ~filterindex
    return
end
fid = fopen(fullfile(pathname,filename),'r');
% handles = setDefaultParametes(handles);
errMsg = '';
while (~feof(fid))
    tline = strtrim(fgetl(fid));
    if  ~isempty(tline) && ~strcmp(tline(1),'%')
        [tok, rest] = strtok(tline, '=');
        tok = strtrim(tok);
        rest = rest(2:end);
        val = str2num(rest);
        thisErrMsg = '';
        switch tok
            case 'phaseFrame'
                set(handles.phase_frame_popup,'Value',val);
            case 'dilationRadius'
                if length(val) <= 1
                    set(handles.seg_dilate,'String',val);
                end
            case 'shift'
                if length(val) == 2 || isempty(val)
                    set(handles.seg_shift,'String',num2str(val));
                else
                    thisErrMsg = [tok 'must be a pair [x y]\n'];
                end
            case 'maxNumOfCells'
                if (length(val)==2 && val(1)< val(2))
                    set(handles.seg_max_cells,'String',num2str(val));
                else
                    thisErrMsg = [tok 'must be a pair [minN maxN]\n'];
                end
            case 'fluo1_filter'
                if val == 1 || ~val
                    set(handles.fluo1_filter_checkbox,'Value',val);
                else
                    thisErrMsg = [tok 'must be 0 or 1\n'];
                end
            case 'fluo1_frameRange'
                if (length(val)==2 && val(1)< val(2))
                    set(handles.fluo1_frames,'String',num2str(val));
                else
                    thisErrMsg = [tok 'must be a pair [minFrame maxFrame]\n'];
                end
            case 'fluo1_bg'
                set(handles.fluo1_bg,'String', val);
            case 'fluo1_lowThresh'
                set(handles.fluo1_low_thresh,'String',val);
            case 'fluo1_uppThresh'
                set(handles.fluo1_upp_thresh,'String',val);
            case 'fluo2_filter'
                if val == 1 || ~val
                    set(handles.fluo2_filter_checkbox,'Value',val);
                else
                    thisErrMsg = [tok 'must be 0 or 1\n'];
                end
            case 'fluo2_bg'
                set(handles.fluo2_bg,'String',val);
            case 'fluo2_uppThresh'
                set(handles.fluo2_upp_thresh,'String',val);            
        end
        errMsg = [errMsg thisErrMsg];
    end
end
if ~isempty(errMsg)
    f = errordlg(errMsg);
    uiwait(f);
    uicontrol(h);
end
currFrameRange = handles.fluo1.frameRange;
handles = getParameters(handles);
if ~isequal(currFrameRange, handles.fluo1.frameRange)
    handles = computeFluoAVG(handles);
end
postprocessSegmentedImage(handles);
guidata(hObject, handles);


% --- Executes on button press in save_param_button.
function save_param_button_Callback(hObject, eventdata, handles)
% hObject    handle to save_param_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname, filterindex] = uiputfile('segm_curation_param.txt');
if ~filterindex
    return
end
parameterFile = fullfile(pathname,filename);
saveParameters(handles,parameterFile)


function saveParameters(handles, parameterFile)
if nargin == 1
    outputDir = handles.expInfoObj.getPathName('output');
    timeStamp = now;
    parameterFile = fullfile(outputDir, ['segm_curation_param_' timeStamp '.txt']);
end
fid = fopen(parameterFile,'w');
if fid
    fprintf(fid,'phaseFrame = %d\n', get(handles.phase_frame_popup,'Value'));
    if ~isempty(handles.dilationRadius)
        fprintf(fid,'dilationRadius = %d\n',handles.dilationRadius);
    else
        fprintf(fid,'dilationRadius = \n');
    end
    if ~isempty(handles.shiftVector)
        fprintf(fid,'shift = %d %d\n',handles.shiftVector(1),handles.shiftVector(2));
    else
        fprintf(fid,'shift = \n');
    end
    if ~isempty(handles.maxNumOfCells)
        fprintf(fid,'maxNumOfCells = %d %d\n', handles.maxNumOfCells(1), handles.maxNumOfCells(2));
    else
        fprintf(fid,'maxNumOfCells = \n');
    end
    if get(handles.fluo1_filter_checkbox,'Value')
        fprintf(fid,'fluo1_filter = 1\n');
    else
        fprintf(fid,'fluo1_filter = 0\n');
    end
    if ~isempty(handles.fluo1.frameRange)
        fprintf(fid,'fluo1_frameRange = %d %d\n', handles.fluo1.frameRange(1),handles.fluo1.frameRange(end));
    else
        fprintf(fid,'fluo1_frameRange = \n');
    end
    if ~isempty(handles.fluo1.bg)
        fprintf(fid,'fluo1_bg = %d\n',handles.fluo1.bg);
    else
        fprintf(fid,'fluo1_bg = \n');
    end
    if ~isempty(handles.fluo1.lowThresh)
        fprintf(fid,'fluo1_lowThresh = %d\n',handles.fluo1.lowThresh);
    else
        fprintf(fid,'fluo1_lowThresh = \n');
    end
    if ~isempty(handles.fluo1.uppThresh)
        fprintf(fid,'fluo1_uppThresh = %d\n',handles.fluo1.uppThresh);
    else
        fprintf(fid,'fluo1_uppThresh = \n');
    end
    if get(handles.fluo2_filter_checkbox,'Value')
        fprintf(fid,'fluo2_filter = 1\n');
    else
        fprintf(fid,'fluo2_filter = 0\n');
    end
    if ~isempty(handles.fluo2.bg)
        fprintf(fid,'fluo2_bg = %d\n',handles.fluo2.bg);
    else
        fprintf(fid,'fluo2_bg = \n');
    end
    if ~isempty(handles.fluo2.uppThresh)
        fprintf(fid,'fluo2_uppThresh = %d\n',handles.fluo2.uppThresh);
    else
        fprintf(fid,'fluo2_uppThresh = \n');
    end
    fclose(fid);
end    
    
function handles = getParameters(handles)
handles.dilationRadius = getProperty(handles.seg_dilate,0,1,1,0);
handles.shiftVector = getProperty(handles.seg_shift,[0 0],2,0,0);
handles.rotationAngle = getProperty(handles.seg_rotate,0,1,0,0);
handles.maxNumOfCells = getProperty(handles.seg_max_cells,[2 8],2,1,1);
handles.fluo1.frameRange = getFrameRange(handles);
handles.fluo1.bg = getProperty(handles.fluo1_bg,[],1,0,1);
handles.fluo1.lowThresh = getProperty(handles.fluo1_low_thresh,[],1,0,1);
handles.fluo1.uppThresh = getProperty(handles.fluo1_upp_thresh,Inf,1,0,1);
handles.fluo2.bg = getProperty(handles.fluo2_bg,[],1,0,1);
handles.fluo2.uppThresh = getProperty(handles.fluo2_upp_thresh,[],1,0,1);


% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
% hObject    handle to save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
outputDir = handles.expInfoObj.getPathName('output');

posIdx = str2double(get(handles.position_edit,'String'));
posName = handles.expInfoObj.getPositionList(posIdx);

segDir = fullfile(outputDir,posName,'SegmentedPhase');
backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
if ~exist(backDir,'dir')
    mkdir(backDir)
    copyfile(segDir,backDir);
end
rmdir(segDir,'s');
mkdir(segDir);
phaseListIdx = get(handles.phase_frame_popup,'Value');
backList = dir(fullfile(backDir,'*.tif*'));
imFileName = backList(phaseListIdx).name;

segIm = handles.segIm;
isBad = handles.cells.isBad;
for i=1:numel(handles.cells.labels)
    cellLabel = handles.cells.labels(i);
    if isBad(i,4) >= 0 && any(isBad(i,:))>0
        segIm(segIm==cellLabel) = 0;
    end
end
   
imwrite(segIm,fullfile(segDir,imFileName));
moveToPosition(handles,posIdx,1);


% --- Executes on button press in manual_select_button.
function manual_select_button_Callback(hObject, eventdata, handles)
% hObject    handle to manual_select_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isempty(handles.phase_axes.Children)
    return
end
phaseIm = handles.phase_axes.Children(end);
if get(hObject,'Value') == 1
    set(hObject,'String','On');
    set(phaseIm,'ButtonDownFcn',@clickOnSegIm,'HitTest','on');
else
    set(hObject,'String','Off');
    set(phaseIm,'ButtonDownFcn',[]);
end
guidata(hObject, handles);

function clickOnSegIm(hObject, varargin)
handles = guidata(hObject);
coord = round(get(handles.phase_axes,'currentpoint'));
segIm = handles.segIm;
blobLabel = segIm(coord(1,2),coord(1,1));
% disp(blobLabel);
isBad = handles.cells.isBad;
if blobLabel>0
    labelIdx = find(handles.cells.labels == blobLabel,1);
    if (isBad(labelIdx,4) >= 0) && (any(isBad(labelIdx,:)) > 0)
        isBad(labelIdx,4) = -1;
    else
        isBad(labelIdx,4) = 1;
    end
    handles.cells.isBad = isBad;
    plotCells(handles.phase_axes, handles.cells.boundaries, handles.cells.isBad, []);
    plotCells(handles.bf_axes, handles.cells.boundaries, handles.cells.isBad, handles.Tbf);
end
guidata(hObject, handles);


% --- Executes on button press in get_fluo1_bkg_button.
function get_fluo1_bkg_button_Callback(hObject, eventdata, handles)
% hObject    handle to get_fluo1_bkg_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
outputDir = handles.expInfoObj.getPathName('output');
sourceDir = handles.expInfoObj.getPathName('source');
fluoChanNames = handles.expInfoObj.getChannelNames('fluo');
fluoChanName = fluoChanNames{1};
positionList = handles.expInfoObj.getPositionList();
nPositions = numel(positionList);

phaseListIdx = get(handles.phase_frame_popup,'Value');
currPosIdx = str2double(get(handles.position_edit,'String'));
bkgArray = nan(1,nPositions);
invT = inv(handles.T);
invT(:,3) = [0;0;1];
tform = affine2d(invT);
R = imref2d(size(handles.fluo1.im));

f = waitbar(0,'Computing average background','CreateCancelBtn','setappdata(gcbf,''canceling'',1)');
setappdata(f,'canceling',0);
counter = 0;
for posIdx = [1: currPosIdx-1 currPosIdx+1:nPositions currPosIdx]
    counter = counter+1;
    if getappdata(f,'canceling')
        break
    end
    waitbar(counter/nPositions, f);
    % Read image
    posName = positionList{posIdx};
    backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
    if ~exist(backDir,'dir')
        backDir = fullfile(outputDir,posName,'SegmentedPhase');
    end
    backList = dir(fullfile(backDir,'*.tif*'));
    imFileName = backList(phaseListIdx).name;
    handles.segIm = imread(fullfile(backDir,imFileName));
    handles.origSegIm = handles.segIm;

    handles = dilateSegmentedImage(handles);
    handles = shiftSegmentedImage(handles);
    handles = rotateSegmentedImage(handles);
 
    segMask = handles.segIm>0;
    segMaskInFluo = imwarp(segMask,tform,'OutputView',R,'FillValues',0);
    fluoImPath = fullfile(sourceDir,posName,fluoChanName,handles.imagefile);
    fluoIm = imread(fluoImPath);
    bkgArray(posIdx) = round(mean(fluoIm(segMaskInFluo == 0)));
end
waitbar(1,f,'Done');
delete(f);
avgBkg = round(mean(bkgArray));
set(handles.fluo1_bg,'String',avgBkg);
fluo1_bg_Callback(handles.fluo1_bg, eventdata, handles)

% --- Executes on button press in get_fluo2_bkg_button.
function get_fluo2_bkg_button_Callback(hObject, eventdata, handles)
% hObject    handle to get_fluo2_bkg_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
outputDir = handles.expInfoObj.getPathName('output');
sourceDir = handles.expInfoObj.getPathName('source');

positionList = handles.expInfoObj.getPositionList();
nPositions = numel(positionList);

phaseListIdx = get(handles.phase_frame_popup,'Value');
currPosIdx = str2double(get(handles.position_edit,'String'));
bkgArray = nan(1,nPositions);
invT = inv(handles.T);
invT(:,3) = [0;0;1];
tform = affine2d(invT);
R = imref2d(size(handles.fluo1.im));

f = waitbar(0,'Computing average background','CreateCancelBtn','setappdata(gcbf,''canceling'',1)');
setappdata(f,'canceling',0);
counter = 0;
for posIdx = [1: currPosIdx-1 currPosIdx+1:nPositions currPosIdx]
    counter = counter+1;
    if getappdata(f,'canceling')
        break
    end
    waitbar(counter/nPositions, f);
    % Read image
    posName = positionList{posIdx};
    backDir = fullfile(outputDir,posName,'SegmentedPhase_backup');
    if ~exist(backDir,'dir')
        backDir = fullfile(outputDir,posName,'SegmentedPhase');
    end
    backList = dir(fullfile(backDir,'*.tif*'));
    imFileName = backList(phaseListIdx).name;
    handles.segIm = imread(fullfile(backDir,imFileName));
    handles.origSegIm = handles.segIm;

    handles = dilateSegmentedImage(handles);
    handles = shiftSegmentedImage(handles);
    handles = rotateSegmentedImage(handles);
 
    segMask = handles.segIm>0;
    segMaskInFluo = imwarp(segMask,tform,'OutputView',R,'FillValues',0);
    fluoImPath = fullfile(sourceDir,posName,handles.cytoxChanName,handles.imagefile);
    fluoIm = imread(fluoImPath);
    bkgArray(posIdx) = round(mean(fluoIm(segMaskInFluo == 0)));
end
waitbar(1,f,'Done');
delete(f);
avgBkg = round(mean(bkgArray));
set(handles.fluo2_bg,'String',avgBkg);
fluo2_bg_Callback(handles.fluo2_bg, eventdata, handles)


% --- Executes on button press in fluo1_fix_button.
function fluo1_fix_button_Callback(hObject, eventdata, handles)
% hObject    handle to fluo1_fix_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value')
    minClim = str2double(get(handles.fluo1_min_clim,'String'));
    maxClim = str2double(get(handles.fluo1_max_clim,'String'));
    im = handles.fluo1.im;
    handles.fluo1.clim = quantile(double(im(:)),[minClim maxClim]);
else
    handles.fluo1.clim = [];
end
setClim(handles,'fluo1');
guidata(hObject, handles);

% Hint: get(hObject,'Value') returns toggle state of fluo1_fix_button


% --- Executes on button press in fluo2_fix_button.
function fluo2_fix_button_Callback(hObject, eventdata, handles)
% hObject    handle to fluo2_fix_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value')
    minClim = str2double(get(handles.fluo2_min_clim,'String'));
    maxClim = str2double(get(handles.fluo2_max_clim,'String'));
    im = handles.fluo2.im;
    handles.fluo2.clim = quantile(double(im(:)),[minClim maxClim]);
else
    handles.fluo2.clim = [];
end
setClim(handles,'fluo2');
guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of fluo2_fix_button


% --- Executes on button press in removeAll.
function removeAll_Callback(hObject, eventdata, handles)
% hObject    handle to removeAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.cells.isBad(:,4) = 1;
plotCellsWrapper(handles);
guidata(hObject, handles);

%Hot keys (by Ivan)
 % --- Executes on key press with focus on figure1 or any of its controls.
function figure1_WindowKeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

keyPressed = eventdata.Key;
 if strcmpi(keyPressed,'escape')
     % set focus to the button
     uicontrol(handles.removeAll);
     % call the callback
     removeAll_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'c')
     % set focus to the button
     uicontrol(handles.forward_button);
     % call the callback
     forward_button_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'z')
     % set focus to the button
     uicontrol(handles.backward_button);
     % call the callback
     backward_button_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'s')
     % set focus to the button
     uicontrol(handles.save_button);
     % call the callback
     save_button_Callback(hObject, eventdata, handles);
 end

 function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

keyPressed = eventdata.Key;
 if strcmpi(keyPressed,'escape')
     % set focus to the button
     uicontrol(handles.removeAll);
     % call the callback
     removeAll_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'c')
     % set focus to the button
     uicontrol(handles.forward_button);
     % call the callback
     forward_button_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'z')
     % set focus to the button
     uicontrol(handles.backward_button);
     % call the callback
     backward_button_Callback(hObject, eventdata, handles);
 elseif strcmpi(keyPressed,'s')
     % set focus to the button
     uicontrol(handles.save_button);
     % call the callback
     save_button_Callback(hObject, eventdata, handles);
 end

% --- Executes on selection change in position_popup.
function position_popup_Callback(hObject, eventdata, handles)
% hObject    handle to position_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns position_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from position_popup
posIdx = get(hObject,'Value');
currPosIdx = str2double(get(handles.position_edit,'String'));
if posIdx ~= currPosIdx
    handles = moveToPosition(handles,posIdx);
    if get(handles.manual_select_button,'Value')
        manual_select_button_Callback(handles.manual_select_button, eventdata, handles)
    end
end
guidata(hObject, handles);
