function outtxt = datatip_callback(obj,eventObj,cellInfo,imageCoord,internalCoord)

if nargin<3
    error('Not enough arguments');
end

if nargin==3
    imageCoord = [];
    internalCoord = [];
end

coord = get(eventObj,'Position');

if isempty(imageCoord) || isempty(internalCoord)
    idx = 0;
else
    idx = imageCoord(:,1) == coord(1) & imageCoord(:,2) == coord(2);
end
if any(idx)
    outtxt = sprintf('%f, %f', internalCoord(idx, 1),internalCoord(idx, 2));
else
    dist = sqrt((cellInfo(:,1)-coord(1)).^2+(cellInfo(:,2)-coord(2)).^2);
    idx = find(dist<3,1);
    if ~isempty(idx)
        outtxt = sprintf('cell %d', cellInfo(idx,3));
    else
        outtxt = sprintf('X:%d\nY:%d', coord(1),coord(2));
    end
end