function [angle, im, T] = getAngularDisplacement(im, angularDisplacement)

if nargin==1
    the_fig = figure;
    imagesc(im);
    title('Draw line for image rotation')
    axis equal
    colormap gray
    
    h = imline;
    the_line = wait(h);
    
    line_vect = the_line(2,:)-the_line(1,:);
    x_axis = [1 0];
    angle = acosd(dot(line_vect, x_axis)/(norm(line_vect)));
    close(the_fig);
else
    angle = angularDisplacement;
end

im_size_b = size(im)+1;
im = imrotate(im, angle, 'bilinear')+1;

im_size_a = size(im)+1;

Ttb = getTranslationMatrix(-[im_size_b(2)/2 im_size_b(1)/2]);
Tr = eye(3);
Tr(1,1) = cosd(angle);
Tr(1,2) = -sind(angle);
Tr(2,1) = sind(angle);
Tr(2,2) = cosd(angle);

Tta = getTranslationMatrix([im_size_a(2)/2 im_size_a(1)/2]);

T = Ttb*Tr*Tta;

end