function  [angle, im, T] = getAngularDisplacementMM(im, debugFlag)

if nargin==1
    debugFlag = 0;
end
se = strel('disk', 2);
BW = imdilate(edge(im),se);

[H,theta,rho] = hough(BW);
P = houghpeaks(H,20,'threshold',ceil(0.3*max(H(:))));
lines = houghlines(BW,theta,rho,P,'FillGap',20,'MinLength',200);

if debugFlag
    figure, imshow(BW), hold on
    for k = 1:length(lines)
       xy = [lines(k).point1; lines(k).point2];
       plot(xy(:,1),xy(:,2),'LineWidth',2,'Color','green');
       plot(xy(1,1),xy(1,2),'x','LineWidth',2,'Color','yellow');
       plot(xy(2,1),xy(2,2),'x','LineWidth',2,'Color','red');
    end
    title('Automatic line detection');
    drawnow
end

angles = 90-[lines.theta];
angle = mean(angles(abs(angles-median(angles))<2));

[angle, im, T] = getAngularDisplacement(im, angle);
figure, imshow(im);
title('Auto-rotated phase-contrast image');