function [roi,centers]  = getBarcodeLocation(im, radiusRange,debugFlag)
% 
if nargin==1 || isempty(radiusRange)
    if size(im,2)>800
        radiusRange = [7 20];
    else
        radiusRange = [7 15];
    end
end
if nargin<3
    debugFlag=0;
end
[centers,radii] = imfindcircles(im,radiusRange);
[~,idx] = min(abs(centers(:,2)-size(im,1)/2));
ind = abs(centers(:,2)-centers(idx,2)) < 5;
y = round(mean(centers(ind,2)));
xmin = round(min(centers(ind,1)));
xmax = round(max(centers(ind,1)));
xshift = min([100, xmin-1, size(im,2)-xmax]);
yshift = min([100, y-1, size(im,1)-y]);
roi = [xmin-xshift y-yshift xmax-xmin+2*xshift 2*yshift];
if debugFlag
    figure, imagesc(im)
    colormap gray, axis image
    viscircles(centers,radii);
    rectangle('Position',roi,'EdgeColor','g');
    title('Barcode ROI')
    drawnow
end