function [pList] = getParticleList(mCells, chanName)

    p = [mCells.particles];
    nFrames = [p.numberOfFrame];
    p = p(nFrames>0);

    if nargin == 2
        chanNames = {p.channelName};
        p = p(strcmp(chanNames,chanName));
    end

    pList.fluoCoord = reshapeArray([p.trajImageCoord]);
    pList.phaseCoord = reshapeArray([p.trajPhaseImageCoord]);
    pList.internalCoord = reshapeArray([p.trajInternalCoord]);
    pList.detectionFrame = [p.cellDetectionFrames];
    pList.chanName = {p.channelName};

end

function M = reshapeArray(a)
    M = [a(1:2:end); a(2:2:end)]';
end