function [expInfoObj] = loadExpInfo(loadDir, loadName)
% Load the array of cells located in loadDir. If loadName is not specified,
% then it loads the first matfile in loadDir.

if nargin < 2
    filePath = fullfile(loadDir,'expInfoObj.mat');
    if ~exist(filePath,'file')
        expInfoList = dir(strcat(loadDir,filesep,'*.mat'));
        filePath = fullfile(loadDir,expInfoList(1).name);
    end
else
    filePath = fullfile(loadDir,loadName);
end

expInfoMatFile = load(filePath);
fieldName = fieldnames(expInfoMatFile);
expInfoObj = expInfoMatFile.(fieldName{1});

end
