function [D] = pdist2cust(X,Y)
% D = pdist2cust(X,Y) is a customized version of pdist2 that computes 
% a matrix of pairwise Euclidean distances between points defined as rows 
% in matrices X and Y. 
% X and Y must have the same number of columns.
% D(i,j) is a Euclidean distance between X(i,:) and Y(j,:)
[mx, nx] = size(X);
[my, ny] = size(Y);

if nx ~= ny
    D = [];
    return
end

D = zeros(mx,my);
for i=1:mx
    for j=1:my
        D(i,j) = norm(X(i,:)-Y(j,:));
    end
end

end
