function [transformationMatrix] = registerWithLandmarks(phaseIm, brightFieldIm)

% Select control points
[brightFieldPoints, phasePoints] = cpselect(brightFieldIm, phaseIm, 'Wait',true);

% Fine tune control points
% phasePoints = cpcorr(phasePoints, brightFieldPoints, phaseIm, brightFieldIm);

% Estimate transformation
transformation = fitgeotrans(brightFieldPoints, phasePoints,'similarity');
transformationMatrix = transformation.T;

%% To display the result
%info = imfinfo(brightField);
%phase_registered = imtransform(phaseIm,t_concord,'XData',[1 info.Width],'YData',[1 info.Height]);
%figure, imshow(imfuse(phase_registered,brightFieldIm,'falsecolor','Scaling','joint','ColorChannels',[1 2 0]));