function saveParameterFile(parameterStruct, savePath)

% Last modified:
% SZ, 2018-08-09. Parse '%' as '\%'.

fid = fopen(savePath,'w');
if fid==-1
    error('Failed to open file for saving parameters:\n%s',savePath);
end

fieldNames = fieldnames(parameterStruct);
% Get all the parameters
for fieldIdx = 1:numel(fieldNames)
    currParam = parameterStruct.(fieldNames{fieldIdx});
    if ischar(currParam)
        saveVal = currParam;
        strrep(saveVal,'%','\%');
    elseif iscellstr(currParam)
        saveVal = strjoin(currParam);
        strrep(saveVal,'%','\%');
    elseif numel(parameterStruct.(fieldNames{fieldIdx})) == 1
        saveVal = num2str(currParam, 8);
    else
        try
            saveVal = ['[' num2str(currParam, 8) ']'];
        catch           
            saveVal = '[';
            for ii = 1:size(currParam,1)
                if ii == size(currParam,1)
                    saveVal = strcat(saveVal,num2str(currParam(ii,:), 8),']');
                else
                    saveVal = strcat(saveVal,num2str(currParam(ii,:), 8),';');
                end
            end
        end
    end
    
    fprintf(fid,'%s = %s \n',fieldNames{fieldIdx},saveVal);
end

fclose(fid);

end
