function lineageL = computeCellLineageLengths(mCells)
    lineageL = ones(numel(mCells),1);
    for i=1:numel(mCells)
        lineageL(i) = computeSingleCellLineageLength(mCells(i));
    end
end

function l = computeSingleCellLineageLength(c)
    if isempty(c.descendants)
        l = 1;
    else
        l_1 = computeSingleCellLineageLength(c.descendants(1));
        l_2 = computeSingleCellLineageLength(c.descendants(2));
        l = 1 + max(l_1,l_2);
    end
end