import os
import re

def getFileList(path_to_file, chan_name = '', first_only = False):
    """supporting function to walk in the expriment directory and return a list of the all files existing in the master directory. For PraNet segmentation of RiteAcquire experiments. 
    arg: chan = 'cbright', to extract images from only phase contrast.
    
    20200410 Kuba
    """
            
    file_list = []
    for (root,_,files) in os.walk(path_to_file):
        #load only the first image
        if first_only:
            if root.endswith(chan_name):
                name = sorted(files)[0]
                file_list.append(os.path.join(root,name))
        #or all images
        else:
            for name in files:
                if re.search(chan_name,root) is not None:
                    if name.endswith(('.tiff','.tif')):
                        file_list.append(os.path.join(root,name))
    
    print("{} files were loaded.".format(len(file_list)))

    return file_list 

def makeDirs(exp_dir, save_dir):
    """"supporting function, making folders to put the segmentation images itno
    args:
    destingation_dir = direction to the experiment directory
    save_dir = SegmentedPhase, or SegmentedChans

    20200424 Kuba
    """
    for (root,_,_) in os.walk(exp_dir):
        if re.search('PreprocessedPhase',root) is not None:
            seg_dir = root.replace('PreprocessedPhase',save_dir)
            print(seg_dir)
            if not os.path.exists(seg_dir):
                os.makedirs(seg_dir)
            # else:
            #     #used to breake, but now it just tries to make a folder in each position directory
            #     #break