import numpy as np
from scipy import ndimage as ndi
from skimage.segmentation import watershed
from skimage.feature import peak_local_max
from skimage.morphology import reconstruction
from skimage.measure import label
from skimage.io import imread, imsave
import matplotlib.pyplot as plt

f_name = '/hdd/RecPAIR/Microscopy/EXP-20-BQ2495/analysis20200602/exp3/prod/Pos1/SegmentedPhase/img_000000006_KubNet.tiff'
label_im = imread(f_name)

#for explanatin of watershed segmentation see:
#1)https://scikit-image.org/docs/dev/auto_examples/segmentation/plot_watershed.html
#2)https://blogs.mathworks.com/steve/2013/11/19/watershed-transform-question-from-tech-support/
bin_im = label_im > 0

distance = ndi.distance_transform_edt(bin_im)
#define connectivity kernel for 2d image

#connectivity size impacts some artifacts.
conn = np.ones((5,5))

h = 2 # h for h minimatransform
#use morphological reconstruction, simillar to the matlab example
distance2 = reconstruction(distance-h,distance)
local_maxi = peak_local_max(distance2, indices=False, footprint=conn)
markers = label(local_maxi)
watershed_labels = watershed(-distance, markers, mask=bin_im, watershed_line=True)

# plt.imshow(bin_im.astype('int') - (watershed_labels>0).astype('int'))
# plt.show()
# plt.imshow((watershed_labels>0).astype('int'))
# plt.show()

#imsave(f_name, watershed_labels, check_contrast=False)