function drawStressedCells(expInfoObj, pos_cell_id, chan_name, crop_to_mask)
%function calls 'grabCellFluos' function in par loop. Saves the cell
% image tower in the floder 'X'_cells, where 'X' is the experiment
% name. Function is intened to be called from 'cellSelect.m' script as a
% final step of analysis of Nikon6 CRISPR/cas9 cutting experiment. 

%initialise save folder
save_dir = [expInfoObj.sourceFolderPath '_cells'];
if exist(save_dir,'dir') ~= 7
    mkdir(save_dir)
end
uni_positions = unique(pos_cell_id(:,1));
for ip = 1:length(uni_positions)
    pcount = uni_positions(ip);
    this_pos = expInfoObj.positions{pcount};
    seg_ims = fullfile(expInfoObj.outputFolderPath, this_pos,'SegmentedPhase');
    seg_ims = dir(fullfile(seg_ims,'*.tiff'));
    target_im_size  = size(imread(fullfile(seg_ims(1).folder, seg_ims(1).name)));
    tmp = load(fullfile(expInfoObj.outputFolderPath, this_pos, 'trackedCells.mat'));
    mCells = tmp.mCells;
    frame_cells = pos_cell_id(pos_cell_id(:,1) == pcount, 2);
%     parfor nCell = 1:length(frame_cells) %loop cell in a position
    for nCell = 1:length(frame_cells) %loop cell in a position
        ic = frame_cells(nCell);
        im_dir = fullfile(expInfoObj.sourceFolderPath, this_pos, chan_name);
        plot_cell = mCells(ic);
        [cellArt2, ~] = grabCellFluos(plot_cell, expInfoObj, this_pos, im_dir, target_im_size, chan_name, crop_to_mask);
        im = cellArt2;
        clims = prctile(im(im(:)>0),[0.01 90]);
        im = im - clims(1);
        im = im / max(im(:));
        figure
        imshow(im)
%         imwrite(im, fullfile(save_dir, [this_pos '_cellb' num2str(ic) '.png']));
%         break
        %     end
    end
% break
end