%script wraps around functions to select cells (by 4x increase in
%fluorescence and outputs a table format for further plotting. This is an
%experimental code, should be improved for plotting the real data.


cas9_ranges = 1:8;

load('/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp5/prod/expInfoObj.mat')
%input: expInfoObj,cas9_ranges, SOS_channel,SOS_increase
T5 = cellSelectFun(expInfoObj,cas9_ranges,'fluo440',4);

load('/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp6/prod/expInfoObj.mat')
%input: expInfoObj,cas9_ranges, SOS_channel,SOS_increase
T6 = cellSelectFun(expInfoObj,cas9_ranges,'fluo440',4);

load('/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp7/prod/expInfoObj.mat')
%input: expInfoObj,cas9_ranges, SOS_channel,SOS_increase
T7 = cellSelectFun(expInfoObj,cas9_ranges,'fluo440',4);

T = [T5;T6;T7];

%% plot fractions of induced cells
plot_table = grpstats(T,{'exp','position','cas9'},{'sum'},'DataVars',{'SOS'});
plot_table.fractions_SOS = plot_table.sum_SOS./plot_table.GroupCount.*100;
out_T = grpstats(T,{'exp','cas9'},{'sum'},'DataVars',{'SOS'});
out_T.fractions_SOS = out_T.sum_SOS./out_T.GroupCount.*100;

g = gramm('x',plot_table.exp,'y',plot_table.fractions_SOS,'color',plot_table.cas9);
g.geom_jitter();
custom = @(y)([nan;nan;mean(y)]);
g.stat_summary('type', custom, 'geom','black_errorbar','width',1)
g.set_names('x','','y','Induced cells [%]','color','Variant');
g.set_title('Fraction of induced cells for 2 conditions');
g.set_point_options('base_size',5);
g.draw()

%% growth rates - somehow i'm getting grap results from this
figure 
hold on
for nn = 1
    
    exp_inf_objects = ['/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp5/prod/expInfoObj.mat';
        '/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp6/prod/expInfoObj.mat';
        '/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/exp7/prod/expInfoObj.mat'];
    load(exp_inf_objects(nn,:))
    
    gather_data = 0;
    
    if gather_data
        cas9_ranges = 1:8;
        gr1 = getGrowthRatesK(expInfoObj,cas9_ranges);
    end
    uni_frames= unique(gr1.frames);
    
    tic
    gr_rates = [];
    for t = 1:10:length(uni_frames)-9
        this_t = uni_frames(t):uni_frames(t)+9;
        indx = ismember(gr1.frames,this_t);
        
        %data for the current time range
        cc = gr1.cellId(indx);
        uni_cc = unique(cc);
        tt = gr1.times(indx);
        areas = gr1.areas(indx);
           gr_rates_tmp = zeros(length(unique(cc)),1);
%         gr_rates_tmp = nan(500,1);
        
        parfor this_c = 1:length(uni_cc)
            this_cc = cc == uni_cc(this_c);
            xdata = tt(this_cc);
            xdata = xdata - xdata(1);
            xdata = xdata / (60 * 1000);
            ydata = areas(this_cc);
            if length(xdata) > 1
                %            x = lsqcurvefit(exp_fun,x0,xdata,ydata,[],[],options);
                f = fit(xdata,ydata,'exp1');
                gr_rates_tmp(this_c) = f.b;
                %        else
                %            gr_rates_tmp(this_c) = nan;
            end%
        end
        gr_rates{t} = gr_rates_tmp; %pool frowth rates
        %    break
    end
    toc
    plot(smooth(cellfun(@(x) nanmean(log(2)./x(abs(x)>0.001 & abs(x) < 10)),gr_rates)))
end
legend('exp5','exp6','exp7')

%% plot growth rates, basic
g=gramm('x',T.bday,'y',T.lifetime,'color',T.exp);
g.set_point_options('base_size',1);
g.stat_smooth();
g.draw();
%% also draw cells

pos_cell_id = table2array(T(T.SOS==1,[2 3]));
pos_cell_id2 = pos_cell_id(100,:);
chan_name = 'fluo594';
drawStressedCells(expInfoObj, pos_cell_id2, chan_name,0)
%
% chan_name = 'fluo440';
% drawStressedCells(expInfoObj, pos_cell_id2, chan_name)




