load('/hdd/RecPAIR/Microscopy/EXP-20-BQ2496/analysis20200612/exp2c/prod/Pos0/trackedCells.mat');
%%
tic
counter = 0;
timing = [];
figure
n1 = 100;
n2 = n1 + 19;
ctr = 1;
for n = n1:n2
    for frame = 1% : size(mCells(n).boundaries,2)
        b = mCells(n).boundaries{frame};
        o = dilatePolygonM(b,1);
        if isempty(o)
            disp(n)
        end
        [bbone, ribs, cshape] = findBackbone(o);
        subplot(5,4,ctr)
        hold on
%         plot(o(:,1),o(:,2),'r')
%         plot(cshape(:,1),cshape(:,2),'k')
        plot(bbone(:,1),bbone(:,2),'r')
        for r = 1:size(ribs)
            xr = [ribs(r,1) ribs(r,3)];
            yr = [ribs(r,2) ribs(r,4)];
            plot(xr,yr,'-k')
        end
        axis equal
    end
    ctr = ctr +1;
end
toc

%%{
tic
figure
n1 = 100;
n2 = n1 + 19;
ctr = 1;
for n = n1:n2
    for frame = 1% : size(mCells(n).boundaries,2)
        b = mCells(n).boundaries{frame};
        o = dilatePolygonM(b,1);
        o = [smooth(o(:,1)) smooth(o(:,2))]+1;
        res = contour2pill_mesh(o, 1, 0.001, 100);
        
        subplot(5,4,ctr)        
%         plot(o(:,1),o(:,2),'k')
        hold on
        bb = zeros(size(res,1),2);
        for r = 1:size(res,1)
            xx = [res(r,1) res(r,3)];
            yy = [res(r,2) res(r,4)];
            plot(xx,yy,'k')
            bb(r,:) = [mean(xx),mean(yy)];
        end
        plot((bb(:,1)),(bb(:,2)),'r')
        axis equal
    end
    ctr = ctr+ 1;
end
toc
%}

%%
b = mCells(n).boundaries{frame};
o = dilatePolygonMath(b);
figure
hold on
plot(b(:,1),b(:,2),'k')
plot(o(:,1),o(:,2),'r')
axis equal

b = mCells(n).boundaries{frame};
o = dilatePolygonM(b,1);
figure
hold on
plot(b(:,1),b(:,2),'k')
plot(o(:,1),o(:,2),'r')
axis equal


%%
function bb = dilatePolygonMath(b)
    x = b(:,1);
    y = b(:,2);
    A = (max(x)-min(x)+1)/(max(x)-min(x));
    Ay = (max(y)-min(y)+10)/(max(y)-min(y));
    xt = A*x+(1-A)*mean(x(1:end-1));
    yt = A*y+(1-A)*mean(y(1:end-1));
    bb = [xt yt];
end

function b2 = dilatePolygonM(b,sz)
%dilate polygon by number of pixels specyfied by 'sz'. To be used with the
%pipeline mCells.boundaries field.
%inputs:
%   b - n x 2 array with x and y positions of boundary points.
%   sz - size to expand in pixels

kr = strel('square',3 + (sz-1)*2);
m = zeros(max(b(:,2)),max(b(:,1)));
idx = sub2ind(size(m), b(:,2), b(:,1));
m(idx) = 1;
m = padarray(m,[sz sz]);
m = imdilate(m, kr);
[iy,ix] = find(m);
b2 = bwtraceboundary(m,[iy(1) ix(1)], 'n', 4);
b2 = fliplr(b2)-sz;

end

function outline = dilateBoundarySweep(b)
% function to expand a polygon **one** pixel in each direction. Similar to
% dilation of an image. Funciton uses radial sweep with marking each extra
% pixel outside of the shape.
% Input: 'b': n by 2 matrix with x and y coordinates of the boundary
% points.
% output: 'outline': n by 2 matrix with x and y coordinates of the expanded
% boundary.

%find the most left pixel and reorient the polygon.
[~,mb] = min(b(:,1));
b = [b(mb:end,:); b(1:mb-1,:)];

%from polyarea; define the orientation of the polygon, if counterclockwise
%then flip. Area of polygon is poistive or negative depending on
%orientation, whatever.
x = b(:,1);
y = b(:,2);
siz = size(x);
area = sum( (x([2:siz(1) 1],:) - x(:,:)).*(y([2:siz(1) 1],:) + y(:,:)))/2;
if area < 0
    b = flipud(b);
end

%repeat the last indexes for checking
b2 = [b; b(1:4,:)];

%define the steps in orientation: e, ne, n, nw etc,
moves = [-1 0;-1 1; 0 1; 1 1; 1 0; 1 -1; 0 -1;-1 -1];

outline = [];
last_pt = [b(1,1)-1 b(1,2)-1]; %set the point directly to the left right as a visited point.

%clockwise sweep of the boundary
for p = 1:size(b,1)
    
    %reorient the moves matrix to start at the last visited point.
    pts = b(p,:) + moves;
    ji = find(all(pts==last_pt,2));
    movesi = [moves(ji:end,:) ; moves(1:ji,:)];
    pts = b(p,:) + movesi;
    
    %have to look 4 points ahead for 1 pixel dilation, avoiding. This is faster than a loop.
    ii1 = find(all(pts==b2(p+1,:),2));
    ii2 = find(all(pts==b2(p+2,:),2));
    ii3 = find(all(pts==b2(p+3,:),2));
    ii4 = find(all(pts==b2(p+4,:),2));
    
    ii = min([ii1 ii2 ii3 ii4]);
    
    %find the first point crossing the line
    ii = ii-1;
    
    %update the last visited point
    if ii > 0
        last_pt = pts(ii,:);
    end
    outline = [outline; pts(1:ii,:)];
end

%clean up repeated points
[~,uniq_out_ind,~] = unique(outline,'rows');
outline = outline(sort(uniq_out_ind),:);
outline = [outline; outline(1,:)];
end

