function b2 = dilatePolygonM(b,sz)
%dilate polygon by number of pixels specyfied by 'sz'. To be used with the
%pipeline mCells.boundaries field.
%inputs:
%   b - n x 2 array with x and y positions of boundary points.
%   sz - size to expand in pixels
%kuba, 2020 uppsala

kr = strel('square',3 + (sz-1)*2);
m = zeros(max(b(:,2)),max(b(:,1)));
idx = sub2ind(size(m), b(:,2), b(:,1));
m(idx) = 1;
m = padarray(m,[sz sz]);
m = imdilate(m, kr);
[iy,ix] = find(m);
b2 = bwtraceboundary(m,[iy(1) ix(1)], 'n', 4);
b2 = fliplr(b2)-sz;

end