% the script is designed to find the mother cell in every microfluidic
% experiment. This is work in progress. Trying to avoid  opening the images
% and doing all the processing on mCells data, which also stores the
% infomration about the channels.

% exp_names = {'exp2','exp5','exp6','exp7'};
% n_fragments = {'/hdd/RecPAIR/Microscopy/EXP-20-BV3202 Cas9 cutting collection/analysis/','/prod/expInfoObj.mat'};
survivals=[];

exp_names = {'exp1'};
% n_fragments = {'/hdd/RecPAIR/Microscopy/EXP-20-BV3204 recA mutants/analysis','prod/expInfoObj.mat'};
n_fragments = {'/hdd/RecPAIR/Microscopy/EXP-20-BV3210 cas9 cuts spot counting experiments/analysis','prod/expInfoObj.mat'};

T_out = [];
for exp = 1:numel(exp_names)
    expInfoObj_name = fullfile(n_fragments{1},exp_names{exp},n_fragments{2});
    load(expInfoObj_name)
% end


%% find the position of the mother-cell channel end
for pcount = 1:16
pos = expInfoObj.positions(pcount);

tmp = load(fullfile(expInfoObj.outputFolderPath, pos{:}, 'trackedCells.mat'));
mCells = tmp.mCells;

chan_locs = expInfoObj.channelLocations{pcount}(:,:,1);

%find which end of the structure is the mother end. Use median of 1000
%cells to remove potential errors from the missegmentation of the first
%couple of cells

num_test_cells = min(1000, numel(mCells));
mother_end = zeros(num_test_cells,1);
to_zero = zeros(num_test_cells,1);
for cc = 1:num_test_cells
    this_cell = mCells(cc);
    this_chan = expInfoObj.channelLocations{pcount}(this_cell.growthChannel,:,1);
    
    %find io the mother cell is closer to the '0' end, or the 'max' end of
    %the image.
    condition = double(this_cell.boundingBoxes(2,end))- ...
                double(this_cell.boundingBoxes(2,1));
    if condition < 0
        to_zero(cc) = 0;
    else
        %should be max of the image, but sufficiently large number will also
        %anchor the cells at the right end
        to_zero(cc) = 1000; 
    end
end
to_zero = median(to_zero);

%%
% for each cell find the distance to the edge of the corresponding channel.
% Then find for each timeframe, for each channel, which cell was the
% closest to the edge - the mother cell.
%make table: cell, channel, time, distance from the mother end

% find the mothers in each channel in each cells

% for each cell find: id, time, growth channel, distance in pixels in 'y'
% dt: nx4 matrix with: cell id, growth channel, time, position 'y'

dt=cell(0,4);
counter = 1;
for cc = 1:length(mCells)
    tcll =  mCells(cc);
%     if tcll.isBadCell ~= 0, continue, end

    if tcll.areas(1) < 100, continue, end %important, ther should be a limit on cell areas!

    tchn = tcll.growthChannel;
    bbox = double(tcll.boundingBoxes);
   
    dmat = bbox(2,:) + bbox(4,:)/2;
    
    lt = tcll.birthFrame:tcll.birthFrame+tcll.lifeTime-1;
    dlt = length(lt);  
    dt =  [dt;[repmat(cc,[dlt,1]) repmat(tchn,[dlt,1]) lt' dmat']];
end
dt = vertcat(dt{:});


%find the cell closest to the growth channel 'mother end' in each channel
%and each frame. 

%add selectro for maximum distance from the edge

uni_t = unique(dt(:,3));
uni_chan = unique(dt(:,2));
num_chan = length(uni_chan);
mc = cell(length(uni_t),0);
%is a parfor loop right here
for tf = 1:length(uni_t)
    thisf = uni_t(tf);
    temp_arr = cell(0,3);
    %data for this time only, to speed up the process
    dt_time = dt(dt(:,3)==thisf,:);
    for tc = 1:num_chan
        thischn = uni_chan(tc);
        idxt = dt_time(:,2) == thischn;
        dt_frame = dt_time(dt_time(:,2) == thischn,:);

        if sum(idxt)>0
            if to_zero
                [~, idxc] = min(dt_frame(:,4));
            else
                [~, idxc] = max(dt_frame(:,4));
            end
            temp_arr = [temp_arr; [thisf thischn dt_frame(idxc,1)]];
        end
    end
    mc{tf} = vertcat(temp_arr{:});
end
mc = vertcat(mc{:});
%here are the mothers!:
mothers_ids = unique(mc(:,3));

%% check if the mother is induced for SOS and if was alive at the time of the induction, which is 20 minutes
SOS_channel_name = 'fluo440';
index_SOS = strcmp(expInfoObj.fluoChannelNames,SOS_channel_name);
SOS_fold_increase = 4;
SOS_moms = false(length(mothers_ids),1);
for motheri = 1:length(mothers_ids)
    this_mother = mCells(mothers_ids(motheri));
    f = this_mother.fluoIntensities(index_SOS,:);
%         t = mCells(ic).birthFrame:mCells(ic).lastFrame;
%         idx = find(~isnan(f));
        [max_v,max_i] = max(f);
        [min_v,min_i] = min(f);
        
        %SOS selector
        selector = max_v > SOS_fold_increase * min_v & max_i > min_i & max_v > 0.5;
        if selector
            stress_level = 1;
        else
            stress_level = 0;
        end
        
%         if stress_level && ismember(40, this_mother.birthFrame:this_mother.lastFrame)
        if ~stress_level && ismember(40, this_mother.birthFrame:this_mother.lastFrame)
            SOS_moms(motheri) = true;
        end
end
SOS_moms = mothers_ids(SOS_moms);


%{
%% to test the code try to plot the rectangles for channels and all first frames of the mothers.
figure
hold on
l = line();
l.LineStyle = ':';
l.Marker = 'none';
% axis equal
tc = expInfoObj.channelLocations{pcount}(:,:,1);
for chani = 1:size(tc,1)
    rectangle('Position',tc(chani,:),'LineStyle','-')
end

for motheri = 1:length(mothers_ids)
    this_mother = mCells(mothers_ids(motheri));
    
    selector = 0;

    if ~isempty(intersect(SOS_moms,mothers_ids(motheri)))
        plot_range = 1:size(this_mother.boundingBoxes,2);
        selector = 1;
    else
        plot_range = 1;
    end
    
    for ij = plot_range
        b = this_mother.boundaries{ij} + double(this_mother.boundingBoxes([1 2],ij))';
        x = b(:,1);
        y = b(:,2);
        if selector
            line(x,y,'Color',[1 0 0])
        else
            line(x,y,'Color',[0 0 0])
        end
    end
end
drawnow
end
%}

%% try some science on selected cells
%try to normalize the lifetime of the cells to start at birthFrame and see
%how long it takes for a cell to divide

life_times = [mCells(SOS_moms).lifeTime];
last_frames =[mCells(SOS_moms).lifeTime]+[mCells(SOS_moms).birthFrame]-1;

time_span = 241;
fractions = nan(time_span,1);
num_cells = numel(life_times);
for t = 1:time_span
    fractions(t) = sum(life_times>t) / num_cells;
end

survivals = [survivals; [life_times' last_frames' repmat(pcount,[num_cells,1])]];

% figure
% line(1:time_span,fractions,'Color',[0 0 0])
% line(life_times(last_frames==time_span),fractions(life_times(last_frames==time_span)),'Marker','o','LineStyle','none','MarkerEdgeColor', [1 0 0])

end

end
%%
survivals(:,4) = survivals(:,3)>8;
fractions = nan(time_span,1);
labels = {'wtCas9','dCas9'};
% labels = {'wtCas9','dCas9'};

figure
% title('survival of recAwt+recA60 and RecA\_E38K\_K72R')
title('survival of wtCas9 and dCas9 cells')
set(gcf,'Color',[1 1 1])
xlabel('time [min]')
ylabel('fraction nondivided')

for mut = 0:1 %first ir RecA60, 2nd is double
for t = 1:time_span
    fractions(t) = sum(survivals(survivals(:,4) == mut) >t) / sum(survivals(:,4) == mut);
end

last_frame_cells = survivals(:,2) == time_span & survivals(:,4) == mut;
x1 = survivals(last_frame_cells,1);
y1 = fractions(x1);

line(1:time_span,fractions,'Color',[0 0 0])

text(round(time_span/2)+5, fractions(round(time_span/2))+0.1,labels{mut+1})
xl = [round(time_span/2) round(time_span/2)+5];
yl = [fractions(round(time_span/2)) fractions(round(time_span/2))+0.08];
line(xl,yl,'Color',[0 0 0])

line(x1, y1, 'Marker','o','LineStyle','none','MarkerEdgeColor', [1 0 0])
end

% end